Require Export algoDotriplets.
Require Export interImplement2.
Section algo.
Variable LL:(list triplet).
Variable maxN:rNat.
Hypothesis HmaxN:maxN=(rnext (maxVarTriplets LL)).
Variable varList:(v:rZ) (rVlt v maxN) ->(list triplet).
Hypothesis varListIn:(v:rZ) (Hv:(rVlt v maxN))(incl (varList v Hv) LL).
Hints Resolve eqStateAddEq eqMemEqState dilemmaPRef eqExceptOnRef.

Theorem eqMemInclState:
  (M1, M2:(Mem maxN)) (eqMem maxN M1 M2) ->
  (inclState (memF maxN M1) (memF maxN M2)).
Intros M1 M2 H'.
Apply inclStateEqStateComp with S1 := (memF maxN M1) S3 := (memF maxN M1); Auto.
Qed.
Hints Resolve eqMemInclState.

Definition memB :=
   [M:(Mem maxN)] [b:bool]
      Cases b of
          true => (cons ((rZPlus zero), (rZMinus zero)) (nil ?))
         | false => (memF maxN M)
      end.

Definition addAndDoTripletsF:
  (M:(Mem maxN)) (a, b:rZ) (Ha:(rVlt a maxN)) (Hb:(rVlt b maxN))
  {R:((Mem maxN) * bool) * (dList maxN) |
    (doTripletsP (addEq (a, b) (memF maxN M)) LL (memFx maxN R)) /\
    ((eqExceptOn maxN M (getMem maxN R) (getList maxN R)) /\
     ((nEq maxN M (getMem maxN R) (getList maxN R)) /\
      (inclState (memF maxN M) (memF maxN (getMem maxN R)))))}.
Intros M a b Ha Hb.
Generalize (refl_equal ? (addEqMem maxN M a b Ha Hb));
 Pattern -1 (addEqMem maxN M a b Ha Hb); Case (addEqMem maxN M a b Ha Hb).
Intros p; Case p; Intros M' b' d'.
Case b'; Auto.
Intros H'; Exists ((M, true), (dNil maxN)); Repeat Split; Auto.
Simpl; Auto.
Apply doTripletsRef; Auto.
Red; Split; Auto.
Red; Auto.
Intros i j H'0.
Apply eqStateContr with p := a q := b; Auto.
Generalize (addEqMemProp28 maxN M a b Ha Hb).
Rewrite H'; Auto.
Intros H'1.
Apply eqStateaddEq2; Auto.
Apply evalInvComp with Maxa := Ha Maxb := Hb; Auto.
Simpl; Auto.
Apply nEqRef; Auto.
Intros H'.
Case (doTripletsF LL maxN HmaxN varList varListIn M' d').
Intros R'; Case R'.
Intros Mb' d'' HMb'; Exists (Mb', (appd maxN d' d'')).
Elim HMb'; Intros H'0 H'1; Elim H'1; Intros H'2 H'3; Elim H'3; Intros H'4 H'5;
 Clear H'3 H'1 HMb'.
Repeat Split; Auto.
Apply doTripletsRTrans with S2 := (memF maxN M'); Auto.
Apply doTripletsRef; Auto.
Generalize (addEqMemProp26 maxN M a b Ha Hb).
Rewrite H'; Auto.
Simpl; Apply eqExceptOnAppd with M2 := M'; Auto.
Generalize (addEqMemExcept maxN M a b Ha Hb); Rewrite H'; Auto.
Simpl; Apply nEqAppd with M2 := M'; Auto.
Generalize (addEqMemIncl maxN M a b Ha Hb); Rewrite H'; Auto.
Generalize (addEqMemNEq maxN M a b Ha Hb); Rewrite H'; Auto.
Apply inclStateTrans with S2 := (memF maxN M'); Auto.
Generalize (addEqMemIncl maxN M a b Ha Hb); Rewrite H'; Auto.
Defined.

Definition Dilemma1F:
  (M1, M2, M3:(Mem maxN))
  (a:rZ) (Ha:(rVlt a maxN)) (eqMem maxN M1 M2) -> (eqMem maxN M1 M3) ->
  {R:((((Mem maxN) * (Mem maxN)) * (Mem maxN)) * bool) * (dList maxN) |
    Cases R of
        (pair (pair (pair (pair M'1 M'2) M'3) b1) dL) =>
          (dilemmaP (memF maxN M1) LL (memB M'1 b1)) /\
          ((nEq maxN M1 M'1 dL) /\
           ((eqMem maxN M'1 M'2) /\
            ((eqMem maxN M'1 M'3) /\ (inclState (memF maxN M1) (memF maxN M'1)))))
    end}.
Intros M1 M2 M3 a Ha EqM1M2 EqM1M3.
Case (addAndDoTripletsF M2 a rZTrue Ha (MaxTrue LL maxN HmaxN)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x; Simpl.
Intros M' b' d'; Case b'.
Intros H'; Elim H'; Intros H'0 H'1; Elim H'1; Intros H'2 H'3; Elim H'3;
 Intros H'4 H'5; Clear H'3 H'1 H'.
Case (addAndDoTripletsF M3 a rZFalse Ha (MaxFalse LL maxN HmaxN)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x; Simpl.
Intros M'' b'' d'' Hmbd''.
Elim Hmbd''; Intros H' H'1; Elim H'1; Intros H'3 H'6; Elim H'6; Intros H'7 H'8;
 Clear H'6 H'1 Hmbd''.
Cut (eqExceptOn maxN M1 M'' d''); [Intros Eq1 | Idtac].
Cut (eqExceptOn maxN M' M'' (appd maxN d' d'')); [Intros Eq2 | Idtac].
Exists ((((M'', (resetMem maxN M1 M'' d'' Eq1)),
          (resetMem maxN M' M'' (appd maxN d' d'') Eq2)), b''), d'').
Repeat Split; Auto.
Generalize H'; Case b''; Auto.
Intros H'9.
Apply dilemmaPSplit
     with a := a b := rZTrue
          S2 := (cons ((rZPlus zero), (rZMinus zero)) (nil rZ * rZ))
          S3 := (cons ((rZPlus zero), (rZMinus zero)) (nil rZ * rZ)); Auto;
 Apply dilemmaPRef; Auto.
Apply doTripletsComp with 1 := H'0; Auto.
Apply doTripletsComp with 1 := H'9; Auto.
Intros H'9.
Apply dilemmaPSplit
     with a := a b := rZTrue
          S2 := (cons ((rZPlus zero), (rZMinus zero)) (nil rZ * rZ))
          S3 := (memF maxN M''); Auto; Apply dilemmaPRef.
Apply doTripletsComp with 1 := H'0; Auto.
Apply doTripletsComp with 1 := H'9; Auto.
Apply nEqInclR with M2 := M3; Auto.
Apply (eqMemSym maxN); Apply resetMemProp; Auto.
Apply (eqMemSym maxN); Apply resetMemProp; Auto.
Apply inclStateEqStateComp with 3 := H'8; Auto.
Apply eqStateSym; Auto.
Apply eqExceptOnAppd with M2 := M2; Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnrTrans with M2 := M3; Auto.
Apply eqExceptOnRef; Auto.
Apply (eqMemTrans maxN) with y := M1; Auto.
Apply (eqMemSym maxN); Auto.
Apply eqExceptOnrTrans with M2 := M3; Auto.
Intros H'; Elim H'; Intros H'0 H'1; Elim H'1; Intros H'2 H'3; Elim H'3;
 Intros H'4 H'5; Clear H'3 H'1 H'.
Case (addAndDoTripletsF M3 a rZFalse Ha (MaxFalse LL maxN HmaxN)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x; Simpl.
Intros M'' b'' d''; Case b''.
Intros H'; Elim H'; Intros H'1 H'3; Elim H'3; Intros H'6 H'7; Elim H'7;
 Intros H'8 H'9; Clear H'7 H'3 H'.
Cut (eqExceptOn maxN M1 M' d'); [Intros Eq1 | Idtac].
Cut (eqExceptOn maxN M'' M' (appd maxN d' d'')); [Intros Eq2 | Idtac].
Exists ((((M', (resetMem maxN M1 M' d' Eq1)),
          (resetMem maxN M'' M' (appd maxN d' d'') Eq2)), false), d').
Repeat Split; Auto.
Apply dilemmaPSplit
     with a := a b := rZTrue S2 := (memF maxN M')
          S3 := (cons ((rZPlus zero), (rZMinus zero)) (nil rZ * rZ)); Auto;
 Apply dilemmaPRef.
Apply doTripletsComp with 1 := H'0; Auto.
Apply doTripletsComp with 1 := H'1; Auto.
Apply nEqInclR with M2 := M2; Auto.
Apply (eqMemSym maxN); Apply resetMemProp; Auto.
Apply (eqMemSym maxN); Apply resetMemProp; Auto.
Apply inclStateEqStateComp with 3 := H'5; Auto.
Apply eqStateSym; Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnAppd with M2 := M3; Auto.
Apply eqExceptOnrTrans with M2 := M2; Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnRef; Auto.
Apply (eqMemTrans maxN) with y := M1; Auto.
Apply (eqMemSym maxN); Auto.
Apply eqExceptOnrTrans with M2 := M2; Auto.
Intros H'; Elim H'; Intros H'1 H'3; Elim H'3; Intros H'6 H'7; Elim H'7;
 Intros H'8 H'9; Clear H'7 H'3 H'.
Apply LetP with h := (interMem LL maxN HmaxN M1 M' M'' d' d'').
Intros u; Case u.
Intros M''' d''' H'; Try Assumption.
Cut (eqExceptOn maxN M' M''' (appd maxN d''' d')); [Intros Eq1 | Idtac].
Cut (eqExceptOn maxN M'' M''' (appd maxN d''' d'')); [Intros Eq2 | Idtac].
Exists ((((M''', (resetMem maxN M' M''' (appd maxN d''' d') Eq1)),
          (resetMem maxN M'' M''' (appd maxN d''' d'') Eq2)), false), d''').
Repeat Split; Auto.
Apply dilemmaPSplit
     with a := a b := rZTrue S2 := (memF maxN M') S3 := (memF maxN M''); Auto.
Apply dilemmaPRef.
Apply doTripletsComp with 1 := H'0; Auto.
Apply dilemmaPRef.
Apply doTripletsComp with 1 := H'1; Auto.
Generalize (interMemProp8 LL maxN HmaxN M1 M' M'' d' d'').
Rewrite <- H'; Simpl; Auto.
Intros H'3; Apply H'3; Auto.
Apply inclStateTrans with S2 := (memF maxN M2); Auto.
Apply inclStateTrans with S2 := (memF maxN M3); Auto.
Apply eqExceptOnrTrans with M2 := M2; Auto.
Apply eqExceptOnrTrans with M2 := M3; Auto.
Generalize (interMemProp5 LL maxN HmaxN M1 M' M'' d' d'').
Rewrite <- H'; Simpl; Auto.
Intros H'3; Apply H'3; Auto.
Apply inclStateTrans with S2 := (memF maxN M2); Auto.
Apply inclStateTrans with S2 := (memF maxN M3); Auto.
Apply (eqMemSym maxN); Apply resetMemProp; Auto.
Apply (eqMemSym maxN); Apply resetMemProp; Auto.
Generalize (interMemProp3 LL maxN HmaxN M1 M' M'' d' d'').
Rewrite <- H'; Simpl; Auto.
Intros H'3; Apply H'3; Auto.
Apply inclStateEqStateComp with 3 := H'5; Auto.
Apply eqStateSym; Auto.
Apply inclStateEqStateComp with 3 := H'9; Auto.
Apply eqStateSym; Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnAppd with M2 := M1; Auto.
Apply eqExceptOnSym; Auto.
Generalize (interMemProp4 LL maxN HmaxN M1 M' M'' d' d'').
Rewrite <- H'; Simpl; Auto.
Intros H'3; Apply H'3; Auto.
Apply inclStateTrans with S2 := (memF maxN M2); Auto.
Apply inclStateTrans with S2 := (memF maxN M3); Auto.
Apply eqExceptOnrTrans with M2 := M3; Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnAppd with M2 := M1; Auto.
Apply eqExceptOnSym; Auto.
Generalize (interMemProp4 LL maxN HmaxN M1 M' M'' d' d'').
Rewrite <- H'; Simpl; Auto.
Intros H'3; Apply H'3; Auto.
Apply inclStateTrans with S2 := (memF maxN M2); Auto.
Apply inclStateTrans with S2 := (memF maxN M3); Auto.
Apply eqExceptOnrTrans with M2 := M2; Auto.
Defined.
End algo.

