Require Export algoDilemma1.
Section algo.
Variable LL:(list triplet).
Variable maxN:rNat.
Hypothesis HmaxN:maxN=(rnext (maxVarTriplets LL)).
Variable varList:(v:rZ) (rVlt v maxN) ->(list triplet).
Hypothesis varListIn:(v:rZ) (Hv:(rVlt v maxN))(incl (varList v Hv) LL).
Hints Resolve eqStateAddEq eqMemEqState dilemmaPRef eqExceptOnRef.
Hints Resolve eqMemInclState.

Definition addAndDoTripletsF2:
  (M:(Mem maxN))
  (a, b, c, d:rZ)
  (Ha:(rVlt a maxN)) (Hb:(rVlt b maxN)) (Hc:(rVlt c maxN)) (Hd:(rVlt d maxN))
  {R:((Mem maxN) * bool) * (dList maxN) |
    (doTripletsP (addEq (a, b) (addEq (c, d) (memF maxN M))) LL (memFx maxN R))
    /\
    ((eqExceptOn maxN M (getMem maxN R) (getList maxN R)) /\
     ((nEq maxN M (getMem maxN R) (getList maxN R)) /\
      (inclState (memF maxN M) (memF maxN (getMem maxN R)))))}.
Intros M a b c d Ha Hb Hc Hd.
Generalize (refl_equal ? (addEqMem maxN M c d Hc Hd));
 Pattern -1 (addEqMem maxN M c d Hc Hd); Case (addEqMem maxN M c d Hc Hd).
Intros p; Case p; Intros M' b' d'.
Case b'; Simpl; Auto.
Intros H'; Exists ((M, true), (dNil maxN)); Repeat Split; Auto.
Simpl; Auto.
Apply doTripletsRef; Auto.
Red; Split; Auto.
Red; Auto.
Intros i j H'0.
Apply eqStateContr with p := c q := d; Auto.
Apply eqStateaddEq2; Auto.
Generalize (addEqMemProp28 maxN M c d Hc Hd).
Rewrite H'; Auto.
Intros H'1.
Apply eqStateaddEq2; Auto.
Apply evalInvComp with Maxa := Hc Maxb := Hd; Auto.
Simpl; Auto.
Apply nEqRef; Auto.
Intros H'.
Case (addAndDoTripletsF LL maxN HmaxN varList varListIn M' a b Ha Hb).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x; Simpl.
Intros M'' b'' d''.
Intros H'0; Elim H'0; Intros H'1 H'2; Elim H'2; Intros H'3 H'4; Elim H'4;
 Intros H'5 H'6; Clear H'4 H'2 H'0.
Exists ((M'', b''), (appd maxN d' d'')); Simpl; Repeat Split; Auto.
Apply doTripletsComp with 1 := H'1; Auto.
Apply eqStateAddEq; Auto.
Generalize (addEqMemProp26 maxN M c d Hc Hd); Rewrite H'; Auto.
Apply eqExceptOnAppd with M2 := M'; Auto.
Generalize (addEqMemExcept maxN M c d Hc Hd); Rewrite H'; Auto.
Apply nEqAppd with M2 := M'; Auto.
Generalize (addEqMemIncl maxN M c d Hc Hd); Rewrite H'; Auto.
Generalize (addEqMemNEq maxN M c d Hc Hd); Rewrite H'; Auto.
Apply inclStateTrans with S2 := (memF maxN M'); Auto.
Generalize (addEqMemIncl maxN M c d Hc Hd); Rewrite H'; Auto.
Defined.

Definition DoInter:
  (M1, M2, M3, M4:(Mem maxN))
  (b1, b2:bool)
  (d1, d2:(dList maxN))
  (eqExceptOn maxN M1 M4 d1) ->
  (eqExceptOn maxN M2 M4 d2) ->
  (nEq maxN M4 M1 d1) ->
  (nEq maxN M4 M2 d2) ->
  (eqMem maxN M3 M4) ->
  (inclState (memF maxN M4) (memF maxN M1)) ->
  (inclState (memF maxN M4) (memF maxN M2)) ->
  {R:((((Mem maxN) * (Mem maxN)) * (Mem maxN)) * bool) * (dList maxN) |
    Cases R of
        (pair (pair (pair (pair M'1 M'2) M'3) b') d') =>
          (eqExceptOn maxN M4 M'1 d') /\
          ((nEq maxN M4 M'1 d') /\
           ((eqMem maxN M'2 M4) /\
            ((eqMem maxN M'3 M4) /\
             ((inclState (memF maxN M4) (memF maxN M'1)) /\
              (eqState
                 (memB maxN M'1 b')
                 (interState (memB maxN M1 b1) (memB maxN M2 b2)))))))
    end}.
Intros M1 M2 M3 M4 b1 b2 d1 d2 Eq1 Eq2 nEq1 nEq2 EqM0 Incl0 Incl1.
Case b1.
Case b2.
Exists ((((M1, (resetMem maxN M2 M4 d2 Eq2)), M3), true), d1); Repeat Split;
 Auto.
Apply eqExceptOnSym; Auto.
Apply resetMemProp; Auto.
Exists ((((M2, (resetMem maxN M1 M4 d1 Eq1)), M3), false), d2); Repeat Split;
 Auto.
Apply eqExceptOnSym; Auto.
Apply resetMemProp; Auto.
Case b2.
Exists ((((M1, (resetMem maxN M2 M4 d2 Eq2)), M3), false), d1); Repeat Split;
 Auto.
Apply eqExceptOnSym; Auto.
Apply resetMemProp; Auto.
Generalize (refl_equal ? (interMem LL maxN HmaxN M3 M1 M2 d1 d2));
 Pattern -1 (interMem LL maxN HmaxN M3 M1 M2 d1 d2);
 Case (interMem LL maxN HmaxN M3 M1 M2 d1 d2).
Intros M'3 d'3 HM'3.
Exists ((((M'3, (resetMem maxN M1 M4 d1 Eq1)), (resetMem maxN M2 M4 d2 Eq2)),
         false), d'3).
Cut (inclState (memF maxN M3) (memF maxN M1)); [Intros Incl2 | Idtac].
2:Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M1);
   Auto.
2:Apply eqMemEqState; Auto.
2:Apply (eqMemSym maxN); Auto.
Cut (inclState (memF maxN M3) (memF maxN M2)); [Intros Incl3 | Idtac].
2:Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M2);
   Auto.
2:Apply eqMemEqState; Auto.
2:Apply (eqMemSym maxN); Auto.
Split; [Idtac | Split; [Idtac | Split; [Idtac | Split; [Idtac | Split]]]]; Auto.
Generalize (interMemProp4 LL maxN HmaxN M3 M1 M2 d1 d2).
Rewrite HM'3; Simpl; Auto.
Intros H'2.
Apply eqExceptOnrTrans with M2 := M3; Auto.
Apply eqExceptOnRef; Auto.
Apply (eqMemSym maxN); Auto.
Apply nEqInclR with M2 := M3; Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M4); Auto.
Apply eqMemEqState; Auto.
Apply (eqMemSym maxN); Auto.
Generalize (interMemProp3 LL maxN HmaxN M3 M1 M2 d1 d2).
Rewrite HM'3; Auto.
Generalize (interMemProp5 LL maxN HmaxN M3 M1 M2 d1 d2).
Rewrite HM'3; Auto.
Apply resetMemProp; Auto.
Apply resetMemProp; Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M3) S3 := (memF maxN M'3); Auto.
Generalize (interMemProp3 LL maxN HmaxN M3 M1 M2 d1 d2).
Rewrite HM'3; Auto.
Simpl; Auto.
Generalize (interMemProp8 LL maxN HmaxN M3 M1 M2 d1 d2).
Rewrite HM'3; Simpl; Auto.
Intros H'; Apply eqStateSym; Apply H'; Auto.
Apply eqExceptOnrTrans with M2 := M4; Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnrTrans with M2 := M4; Auto.
Apply eqExceptOnSym; Auto.
Defined.

Definition Dilemma2F:
  (M1, M2, M3, M4:(Mem maxN))
  (a, b:rZ)
  (Ha:(rVlt a maxN))
  (Hb:(rVlt b maxN))
  (eqMem maxN M1 M2) -> (eqMem maxN M1 M3) -> (eqMem maxN M1 M4) ->
  {R:(((((Mem maxN) * (Mem maxN)) * (Mem maxN)) * (Mem maxN)) * bool) *
     (dList maxN) | Cases R of
                        (pair (pair (pair (pair (pair M'1 M'2) M'3) M'4) b1) dL)
                          =>
                          (dilemmaP (memF maxN M1) LL (memB maxN M'1 b1)) /\
                          ((nEq maxN M1 M'1 dL) /\
                           ((eqMem maxN M'1 M'2) /\
                            ((eqMem maxN M'1 M'3) /\
                             ((eqMem maxN M'1 M'4) /\
                              (inclState (memF maxN M1) (memF maxN M'1))))))
                    end}.
Intros M1 M2 M3 M4 a b Ha Hb EqM1M2 EqM1M3 EqM1M4.
Case (addAndDoTripletsF2
        M2 a rZTrue b rZTrue Ha (MaxTrue LL maxN HmaxN) Hb
        (MaxFalse LL maxN HmaxN)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x; Simpl.
Intros M' b' d'.
Intros H'; Elim H'; Intros H'0 H'1; Elim H'1; Intros H'2 H'3; Elim H'3;
 Intros H'4 H'5; Clear H'3 H'1 H'.
Case (addAndDoTripletsF2
        M3 a rZTrue b rZFalse Ha (MaxTrue LL maxN HmaxN) Hb
        (MaxFalse LL maxN HmaxN)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x; Simpl.
Intros M'' b'' d''.
Intros H'; Elim H'; Intros H'1 H'3; Elim H'3; Intros H'6 H'7; Elim H'7;
 Intros H'8 H'9; Clear H'7 H'3 H'.
Case (DoInter M' M'' M1 M4 b' b'' d' d''); Auto.
Apply eqExceptOnrTrans with M2 := M2; Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnRef; Auto.
Apply (eqMemTrans maxN) with y := M1; Auto.
Apply (eqMemSym maxN); Auto.
Apply eqExceptOnrTrans with M2 := M3; Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnRef; Auto.
Apply (eqMemTrans maxN) with y := M1; Auto.
Apply (eqMemSym maxN); Auto.
Apply nEqInclR with M2 := M2; Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M4); Auto.
Apply eqStateTrans with S2 := (memF maxN M1); Auto.
Apply eqStateSym; Auto.
Apply nEqInclR with M2 := M3; Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M4); Auto.
Apply eqStateTrans with S2 := (memF maxN M1); Auto.
Apply eqStateSym; Auto.
Apply inclStateTrans with S2 := (memF maxN M2); Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M4); Auto.
Apply eqStateTrans with S2 := (memF maxN M1); Auto.
Apply eqStateSym; Auto.
Apply inclStateTrans with S2 := (memF maxN M3); Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M4); Auto.
Apply eqStateTrans with S2 := (memF maxN M1); Auto.
Apply eqStateSym; Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M'1 M'2 M'3 b0 d0 H'; Elim H'; Intros H'3 H'7; Elim H'7;
 Intros H'10 H'11; Elim H'11; Intros H'12 H'13; Elim H'13; Intros H'14 H'15;
 Elim H'15; Intros H'16 H'17; Clear H'15 H'13 H'11 H'7 H'.
Case (addAndDoTripletsF2
        M'2 a rZFalse b rZTrue Ha (MaxFalse LL maxN HmaxN) Hb
        (MaxTrue LL maxN HmaxN)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x; Simpl.
Intros M''' b''' d'''.
Intros H'; Elim H'; Intros H'7 H'11; Elim H'11; Intros H'13 H'15; Elim H'15;
 Intros H'18 H'19; Clear H'15 H'11 H'.
Case (DoInter M'1 M''' M'3 M4 b0 b''' d0 d'''); Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnrTrans with M2 := M'2; Auto.
Apply eqExceptOnSym; Auto.
Apply nEqInclR with M2 := M'2; Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M4); Auto.
Apply eqStateSym; Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M'2) S3 := (memF maxN M''');
 Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M''1 M''2 M''3 b1 d1 H'; Elim H'; Intros H'11 H'15; Elim H'15;
 Intros H'20 H'21; Elim H'21; Intros H'22 H'23; Elim H'23; Intros H'24 H'25;
 Elim H'25; Intros H'26 H'27; Clear H'25 H'23 H'21 H'15 H'.
Case (addAndDoTripletsF2
        M''2 a rZFalse b rZFalse Ha (MaxFalse LL maxN HmaxN) Hb
        (MaxFalse LL maxN HmaxN)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x; Simpl.
Intros M'''' b'''' d''''.
Intros H'; Elim H'; Intros H'15 H'21; Elim H'21; Intros H'23 H'25; Elim H'25;
 Intros H'28 H'29; Clear H'25 H'21 H'.
Case (DoInter M''1 M'''' M''3 M4 b1 b'''' d1 d''''); Auto.
Apply eqExceptOnSym; Auto.
Apply eqExceptOnrTrans with M2 := M''2; Auto.
Apply eqExceptOnSym; Auto.
Apply nEqInclR with M2 := M''2; Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M4) S3 := (memF maxN M4); Auto.
Apply eqStateSym; Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M''2) S3 := (memF maxN M'''');
 Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M'''1 M'''2 M'''3 b2 d2 H'; Elim H'; Intros H'21 H'25; Elim H'25;
 Intros H'30 H'31; Elim H'31; Intros H'32 H'33; Elim H'33; Intros H'34 H'35;
 Elim H'35; Intros H'36 H'37; Clear H'35 H'33 H'31 H'25 H'.
Cut (eqExceptOn maxN M'''2 M'''1 d2); [Intros fEq1 | Idtac].
2:Apply eqExceptOnrTrans with M2 := M4; Auto.
Cut (eqExceptOn maxN M'''3 M'''1 d2); [Intros fEq2 | Idtac]; Auto.
2:Apply eqExceptOnrTrans with M2 := M4; Auto.
Cut (eqExceptOn maxN M4 M'''1 d2); [Intros fEq3 | Idtac]; Auto.
Exists (((((M'''1, (resetMem maxN M'''2 M'''1 d2 fEq1)),
           (resetMem maxN M'''3 M'''1 d2 fEq2)),
          (resetMem maxN M4 M'''1 d2 fEq3)), b2), d2).
Repeat Split; Auto.
Apply dilemmaPSplit
     with a := a b := rZTrue
          S2 := (interState (memB maxN M' b') (memB maxN M'' b''))
          S3 := (interState (memB maxN M''' b''') (memB maxN M'''' b'''')).
Apply dilemmaPSplit
     with a := b b := rZTrue S2 := (memB maxN M' b') S3 := (memB maxN M'' b'');
 Auto; Apply dilemmaPRef.
Apply doTripletsComp with 1 := H'0; Auto.
Apply eqStateTrans
     with S2 := (addEq (b, rZTrue) (addEq (a, rZTrue) (memF maxN M2))); Auto.
Apply addEq2SumEq; Auto.
Apply doTripletsComp with 1 := H'1; Auto.
Apply eqStateTrans
     with S2 := (addEq (b, rZFalse) (addEq (a, rZTrue) (memF maxN M3))); Auto.
Apply addEq2SumEq; Auto.
Apply dilemmaPSplit
     with a := b b := rZTrue S2 := (memB maxN M''' b''')
          S3 := (memB maxN M'''' b''''); Auto; Apply dilemmaPRef.
Apply doTripletsComp with 1 := H'7; Auto.
Apply eqStateTrans
     with S2 := (addEq (b, rZTrue) (addEq (a, rZFalse) (memF maxN M'2))); Auto.
Repeat Apply eqStateAddEq; Auto.
Apply eqStateTrans with S2 := (memF maxN M4); Auto.
Apply eqStateSym; Auto.
Apply addEq2SumEq; Auto.
Apply doTripletsComp with 1 := H'15; Auto.
Apply eqStateTrans
     with S2 := (addEq (b, rZFalse) (addEq (a, rZFalse) (memF maxN M''2))); Auto.
Repeat Apply eqStateAddEq; Auto.
Apply eqStateTrans with S2 := (memF maxN M4); Auto.
Apply eqStateSym; Auto.
Apply addEq2SumEq; Auto.
Apply eqStateTrans
     with S2 :=
          (interState
             (memB maxN M'1 b0)
             (interState (memB maxN M''' b''') (memB maxN M'''' b''''))); Auto.
Apply eqStateTrans
     with S2 :=
          (interState
             (interState (memB maxN M'1 b0) (memB maxN M''' b'''))
             (memB maxN M'''' b'''')); Auto.
Apply eqStateTrans
     with S2 := (interState (memB maxN M''1 b1) (memB maxN M'''' b'''')); Auto.
Apply nEqInclR with M2 := M4; Auto.
Apply (eqMemSym maxN); Auto.
Apply resetMemProp; Auto.
Apply (eqMemSym maxN); Auto.
Apply resetMemProp; Auto.
Apply (eqMemSym maxN); Auto.
Apply resetMemProp; Auto.
Apply inclStateEqStateComp with 3 := H'36; Auto.
Apply eqStateSym; Auto.
Defined.
End algo.
