Require Export algoDotriplet.
Require Export Inverse_Image.
Section algo.
Variable LL:(list triplet).
Variable maxN:rNat.
Hypothesis HmaxN:maxN=(rnext (maxVarTriplets LL)).
Variable varList:(v:rZ) (rVlt v maxN) ->(list triplet).
Hypothesis varListIn:(v:rZ) (Hv:(rVlt v maxN))(incl (varList v Hv) LL).

Definition doTripletsAuxF:
  (L:(list triplet)) (M:(Mem maxN)) (incl L LL) ->
  {R:((Mem maxN) * bool) * (dList maxN) |
    (doTripletsP (memF maxN M) L (memFx maxN R)) /\
    ((eqExceptOn maxN M (getMem maxN R) (getList maxN R)) /\
     ((nEq maxN M (getMem maxN R) (getList maxN R)) /\
      (inclState (memF maxN M) (memF maxN (getMem maxN R)))))}.
Intros L1; Elim L1; Clear L1.
Intros M incl0; Exists ((M, false), (dNil maxN)); Simpl; Split; Auto.
Repeat Split; Auto.
Apply nEqRef; Auto.
Intros t L2 Rec M incl0.
Cut (incl L2 LL); [Intros incl1 | Apply incl_tran with m := (cons t L2)];
 Auto with datatypes.
Cut (In t LL); [Intros in0 | Red in incl0; Apply incl0]; Auto with datatypes.
Case (doTripletF LL maxN HmaxN M t in0).
Intros x; Case x; Clear x.
Intros R1; Generalize (refl_equal ? R1); Pattern -1 R1; Case R1.
Intros x; Case x; Clear x.
Intros M1 b1 L1; Case b1.
Simpl; Intros H' H'0; Elim H'0; Clear H'0; Intros H'0 H'1; Elim H'1; Clear H'1;
 Intros H'1 H'2; Elim H'2; Clear H'2; Intros H'2 H'3.
Exists R1; Rewrite H'; Repeat Split; Auto.
Elim H'0; Intros S E; Elim E; Intros H'0 H'2; Clear E H'1.
Apply doTripletsTrans with S2 := S t := t; Auto with datatypes.
Simpl; Intros H' H'0; Elim H'0; Clear H'0; Intros H'0 H'1; Elim H'1; Clear H'1;
 Intros H'1 H'2; Elim H'2; Clear H'2; Intros H'2 H'3.
Case (Rec M1 incl1).
Intros R2; Generalize (refl_equal ? R2); Pattern -1 R2; Case R2.
Intros Mb L3 EqL2 H'5; Exists (Mb, (appd maxN L1 L3)).
Generalize H'5; Clear H'5; Case Mb; Simpl; Auto.
Intros m b; Case b; Auto.
Intros H'5; Elim H'5; Clear H'5; Intros H'5 H'6; Elim H'6; Clear H'6;
 Intros H'6 H'7; Elim H'7; Clear H'7; Intros H'7 H'8; Repeat Split; Auto.
Elim H'0; Intros S E; Elim E; Intros H'4 H'9; Clear E H'0.
Apply doTripletsTrans with S2 := S t := t; Auto with datatypes.
Apply doTripletsComp
     with S1 := (memF maxN M1)
          S2 := (cons ((rZPlus zero), (rZMinus zero)) (nil rZ * rZ)); Auto.
Apply doTripletsInclList with L1 := L2; Auto with datatypes.
Apply eqExceptOnAppd with M2 := M1; Auto.
Apply nEqAppd with M2 := M1; Auto.
Apply inclStateTrans with S2 := (memF maxN M1); Auto.
Intros H'5; Elim H'5; Clear H'5; Intros H'5 H'6; Elim H'6; Clear H'6;
 Intros H'6 H'7; Elim H'7; Clear H'7; Intros H'7 H'8; Repeat Split; Auto.
Elim H'0; Intros S E; Elim E; Intros H'4 H'9; Clear E H'0.
Apply doTripletsTrans with S2 := S t := t; Auto with datatypes.
Apply doTripletsComp with S1 := (memF maxN M1) S2 := (memF maxN m); Auto.
Apply doTripletsInclList with L1 := L2; Auto with datatypes.
Apply eqExceptOnAppd with M2 := M1; Auto.
Apply nEqAppd with M2 := M1; Auto.
Apply inclStateTrans with S2 := (memF maxN M1); Auto.
Intros H'; Case (Rec M incl1).
Intros Res H'0; Elim H'0; Clear H'0; Intros H'0 H'1; Elim H'1; Clear H'1;
 Intros H'1 H'2; Elim H'2; Clear H'2; Intros H'2 H'3.
Exists Res; Repeat (Split; Auto).
Apply doTripletsInclList with L1 := L2; Auto with datatypes.
Qed.

Definition doTripletsF:
  (M:(Mem maxN)) (Lv:(dList maxN))
  {R:((Mem maxN) * bool) * (dList maxN) |
    (doTripletsP (memF maxN M) LL (memFx maxN R)) /\
    ((eqExceptOn maxN M (getMem maxN R) (getList maxN R)) /\
     ((nEq maxN M (getMem maxN R) (getList maxN R)) /\
      (inclState (memF maxN M) (memF maxN (getMem maxN R)))))}.
Intros M; Pattern M;
 Apply well_founded_induction with A := (Mem maxN) R := (ltMem maxN); Clear M;
 Auto.
Unfold ltMem; Apply wf_inverse_image with B := State.
Apply ltStateWf; Auto.
Intros M RecLt L1; Case L1; Clear L1.
Intros L'1; Elim L'1.
Intros H'; Exists ((M, false), (dNil maxN)); Repeat Split; Simpl; Auto.
Apply nEqRef; Auto.
Intros v Lv RecLv Olv.
Cut (OlistRz Lv) /\ ((a:rZ) (In a Lv) ->(rVlt a maxN)); [Intros HLv | Idtac].
2:Elim Olv; Intros H' H'0; Clear Olv; (Split; Auto with datatypes).
2:Red; Apply OlistInv with a := v; Auto.
Cut (rVlt v maxN); [Intros Hv | Idtac].
2:Elim Olv; Auto with datatypes.
Case (doTripletsAuxF (varList v Hv) M (varListIn v Hv)).
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M1 b1 L1; Case b1; Simpl.
Intros H'0; Exists ((M1, true), L1); Simpl.
Elim H'0; Clear H'0; Intros H'0 H'1; Elim H'1; Clear H'1; Intros H'1 H'2;
 Elim H'2; Clear H'2; Intros H'2 H'3; Repeat Split; Auto.
Apply doTripletsInclList with L1 := (varList v Hv); Auto with datatypes.
Intros H'0; Case (idDnilP maxN L1); Intros id0.
Cut (ltMem maxN M1 M); [Intros ltM1 | Idtac].
Cut (dList maxN); [Intros Lv' | Exists Lv; Auto].
Case (RecLt M1 ltM1 (appd maxN L1 Lv')).
Intros x; Case x; Clear x.
Intros Mb2 d H'0; Elim H'0; Intros H'2 H'5; Elim H'5; Intros H'6 H'7;
 Clear H'5 H'0.
Exists (Mb2, (appd maxN L1 d)); Try Rewrite H'; Auto.
Generalize H'1; Clear H'1; Case Mb2.
Intros m b; Case b; Simpl; Auto.
Intros H'1; Elim H'1; Clear H'1; Intros H'1 H'8; Elim H'8; Clear H'8;
 Intros H'8 H'9; Elim H'9; Clear H'9; Intros H'9 H'10; Repeat Split; Auto.
Apply doTripletsRTrans with S2 := (memF maxN M1); Auto.
Apply doTripletsInclList with L1 := (varList v Hv); Auto.
Apply eqExceptOnAppd with M2 := M1; Auto.
Apply nEqAppd with M2 := M1; Auto.
Elim H'7; Intros H'0 H'3; Clear H'7; Auto.
Elim H'7; Intros H'0 H'3; Clear H'7; Auto.
Elim H'7; Intros H'0 H'3; Clear H'7; Auto.
Apply inclStateTrans with S2 := (memF maxN M1); Auto.
Intros H'1; Elim H'1; Clear H'1; Intros H'1 H'8; Elim H'8; Clear H'8;
 Intros H'8 H'9; Elim H'9; Clear H'9; Intros H'9 H'10; Repeat Split; Auto.
Apply doTripletsRTrans with S2 := (memF maxN M1); Auto.
Apply doTripletsInclList with L1 := (varList v Hv); Auto.
Apply eqExceptOnAppd with M2 := M1; Auto.
Apply nEqAppd with M2 := M1; Auto.
Elim H'7; Intros H'0 H'3; Clear H'7; Auto.
Elim H'7; Intros H'0 H'3; Clear H'7; Auto.
Elim H'7; Intros H'0 H'3; Clear H'7; Auto.
Apply inclStateTrans with S2 := (memF maxN M1); Auto.
Apply MemLtMem; Auto.
Elim H'0; Intros H'1 H'2; Elim H'2; Intros H'3 H'4; Elim H'4; Intros H'5 H'6;
 Clear H'4 H'2 H'0; Auto.
Elim H'0; Intros H'1 H'2; Elim H'2; Intros H'3 H'4; Elim H'4; Intros H'5 H'6;
 Red in H'5; Clear H'4 H'2 H'0; Auto.
Exact (RecLv HLv); Auto.
Defined.
End algo.

