Require Export algoDilemma1.
Section algo.
Variable LL:(list triplet).
Variable maxN:rNat.
Hypothesis HmaxN:maxN=(rnext (maxVarTriplets LL)).
Variable varList:(v:rZ) (rVlt v maxN) ->(list triplet).
Hypothesis varListIn:(v:rZ) (Hv:(rVlt v maxN))(incl (varList v Hv) LL).
Hints Resolve eqStateAddEq eqMemEqState dilemmaPRef eqExceptOnRef.
Hints Resolve eqMemInclState.

Definition Sat1Aux:
  (n:rNat) (M1, M2, M3:(Mem maxN)) (eqMem maxN M1 M2) -> (eqMem maxN M1 M3) ->
  {R:((((Mem maxN) * (Mem maxN)) * (Mem maxN)) * bool) * (dList maxN) |
    Cases R of
        (pair (pair (pair (pair M'1 M'2) M'3) b1) dL) =>
          (stalmarckP (memF maxN M1) LL (memB maxN M'1 b1)) /\
          ((nEq maxN M1 M'1 dL) /\
           ((eqMem maxN M'1 M'2) /\
            ((eqMem maxN M'1 M'3) /\ (inclState (memF maxN M1) (memF maxN M'1)))))
    end}.
Intros n; Pattern n.
Apply well_founded_induction with R := (mBL (rnext maxN)).
Apply mBLWf; Auto.
Intros n' Rec M1 M2 M3 H'0 H'1.
Case (rltDec n' maxN); Intros s; [Case s; Clear s; Intros s | Idtac].
Case (eMZ maxN M1 n' s).
Intros H'.
Apply (Rec (rnext n')) with M1 := M1 M2 := M2 M3 := M3; Auto.
Red; Split; Auto.
Intros H'.
Case (Dilemma1F LL maxN HmaxN varList varListIn M1 M2 M3 (rZPlus n') s); Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M'1 M'2 M'3 b' d'; Case b'; Intros H'2; Elim H'2; Intros H'3 H'4;
 Elim H'4; Intros H'5 H'6; Elim H'6; Intros H'7 H'8; Elim H'8; Intros H'9 H'10;
 Clear H'8 H'6 H'4 H'2.
Exists ((((M'1, M'2), M'3), true), d'); Repeat Split; Auto.
Apply stalmarckTrans with 1 := H'3; Auto.
Case (Rec (rnext n')) with M1 := M'1 M2 := M'2 M3 := M'3; Auto.
Red; Split; Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M''1 M''2 M''3 b'' d'' H'2; Elim H'2; Intros H'4 H'6; Elim H'6;
 Intros H'8 H'11; Elim H'11; Intros H'12 H'13; Elim H'13; Intros H'14 H'15;
 Try Exact H'15; Clear H'13 H'11 H'6 H'2.
Exists ((((M''1, M''2), M''3), b''), (appd maxN d' d'')); Repeat Split; Auto.
Apply stalmarckTrans with 1 := H'3; Auto.
Apply nEqAppd with M2 := M'1; Auto.
Apply inclStateTrans with S2 := (memF maxN M'1); Auto.
Exists ((((M1, M2), M3), false), (dNil maxN)); Repeat Split; Auto.
Apply nEqRef; Auto.
Exists ((((M1, M2), M3), false), (dNil maxN)); Repeat Split; Auto.
Apply nEqRef; Auto.
Qed.

Definition ltT :=
   [R1, R2:(Mem maxN)](ltState (rZList maxN) (memF maxN R1) (memF maxN R2)).

Theorem ltTWf: (well_founded (Mem maxN) ltT).
Apply (wf_inverse_image ? ? (ltState (rZList maxN)) [R:(Mem maxN)](memF maxN R)).
Apply ltStateWf; Auto.
Qed.

Definition Sat1:
  (M1, M2, M3:(Mem maxN)) (eqMem maxN M1 M2) -> (eqMem maxN M1 M3) ->
  {R:(((Mem maxN) * (Mem maxN)) * (Mem maxN)) * bool | Cases R of
                                                           (pair
                                                              (pair
                                                                 (pair M'1 M'2)
                                                                   M'3) b1) =>
                                                             (stalmarckP
                                                                (memF maxN M1)
                                                                LL
                                                                (memB
                                                                   maxN M'1 b1))
                                                             /\
                                                             ((eqMem
                                                                 maxN M'1 M'2)
                                                              /\
                                                              (eqMem
                                                                 maxN M'1 M'3))
                                                       end}.
Intros M1; Pattern M1; Apply well_founded_induction with R := ltT; Clear M1;
 Auto.
Try Exact ltTWf.
Intros M1 Rec.
Intros M2 M3 H' H'0.
Case (Sat1Aux (rnext zero) M1 M2 M3); Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M'1 M'2 M'3 b' d'.
Case b'.
Intros H'1; Elim H'1; Intros H'2 H'3; Elim H'3; Intros H'4 H'5; Elim H'5;
 Intros H'6 H'7; Elim H'7; Intros H'8 H'9; Clear H'7 H'5 H'3 H'1.
Exists (((M'1, M'2), M'3), true); Split; Auto.
Case (idDnilP maxN d').
Intros H'1 H'2; Elim H'2; Intros H'3 H'4; Elim H'4; Intros H'5 H'6; Elim H'6;
 Intros H'7 H'8; Elim H'8; Intros H'9 H'10; Clear H'8 H'6 H'4 H'2.
Cut (ltT M'1 M1); [Intros lt0 | Idtac].
Case (Rec M'1 lt0 M'2 M'3); Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M''1 M''2 M''3 b'' H'2; Elim H'2; Intros H'4 H'6; Clear H'2.
Exists (((M''1, M''2), M''3), b''); Split; Auto.
Apply stalmarckrTrans with S2 := (memF maxN M'1); Auto.
Red; Auto.
Change (ltMem maxN M'1 M1).
Apply MemLtMem; Auto.
Intros H'1 H'2; Elim H'2; Intros H'3 H'4; Elim H'4; Intros H'5 H'6; Elim H'6;
 Intros H'7 H'8; Elim H'8; Intros H'9 H'10; Clear H'8 H'6 H'4 H'2.
Exists (((M'1, M'2), M'3), false); Split; Auto.
Defined.
End algo.

