Require Export algoDilemma2.
Require Export algoSat1.
Require Export lexProd.
Section algo.
Variable LL:(list triplet).
Variable maxN:rNat.
Hypothesis HmaxN:maxN=(rnext (maxVarTriplets LL)).
Variable varList:(v:rZ) (rVlt v maxN) ->(list triplet).
Hypothesis varListIn:(v:rZ) (Hv:(rVlt v maxN))(incl (varList v Hv) LL).
Hints Resolve eqStateAddEq eqMemEqState dilemmaPRef eqExceptOnRef.

Definition lt2M := (lexProd ? (mBL (rnext maxN))).

Theorem lt2MWf: (well_founded rNat * rNat lt2M).
Unfold lt2M; Apply well_founded_lex; Auto.
Apply mBLWf; Auto.
Qed.

Definition Sat2Aux:
  (nm:rNat * rNat)
  (M1, M2, M3, M4:(Mem maxN))
  (eqMem maxN M1 M2) -> (eqMem maxN M1 M3) -> (eqMem maxN M1 M4) ->
  {R:(((((Mem maxN) * (Mem maxN)) * (Mem maxN)) * (Mem maxN)) * bool) *
     (dList maxN) | Cases R of
                        (pair (pair (pair (pair (pair M'1 M'2) M'3) M'4) b1) dL)
                          =>
                          (stalmarckP (memF maxN M1) LL (memB maxN M'1 b1)) /\
                          ((nEq maxN M1 M'1 dL) /\
                           ((eqMem maxN M'1 M'2) /\
                            ((eqMem maxN M'1 M'3) /\
                             ((eqMem maxN M'1 M'4) /\
                              (inclState (memF maxN M1) (memF maxN M'1))))))
                    end}.
Intros n; Pattern n.
Apply well_founded_induction with R := lt2M.
Try Exact lt2MWf.
Intros x; Case x; Clear x; Intros n' m'.
Intros Rec M1 M2 M3 M4 H'1 H'2 H'3.
Case (rltDec n' maxN); Intros s; [Case s; Clear s; Intros s | Idtac].
Case (eMZ maxN M1 n' s).
Intros H'.
Case (rltDec m' n'); Intros s'; [Case s'; Clear s'; Intros s' | Idtac].
Apply (Rec (n', (rnext m'))) with M1 := M1 M2 := M2 M3 := M3 M4 := M4; Auto.
Red; Auto.
Apply lexProd1; Auto.
Red; Split; Auto.
Apply rltTransRnext1 with m := n'; Auto.
Apply rltTrans with y := maxN; Auto.
Apply (Rec ((rnext n'), (rnext zero))) with M1 := M1 M2 := M2 M3 := M3 M4 := M4;
 Auto.
Red.
Apply lexProd2; Auto.
Red; Split; Auto.
Apply (Rec ((rnext n'), (rnext zero))) with M1 := M1 M2 := M2 M3 := M3 M4 := M4;
 Auto.
Red.
Apply lexProd2; Auto.
Red; Split; Auto.
Intros H'.
Case (rltDec m' n'); Intros s'; [Case s'; Clear s'; Intros s' | Idtac].
Case (eMZ maxN M1 m').
Apply rltTrans with y := n'; Auto.
Intros H''.
Apply (Rec (n', (rnext m'))) with M1 := M1 M2 := M2 M3 := M3 M4 := M4; Auto.
Red; Apply lexProd1; Auto.
Red; Split; Auto.
Apply rnextMono; Auto.
Apply rltTrans with y := n'; Auto.
Intros H''.
Case (Dilemma2F
        LL maxN HmaxN varList varListIn M1 M2 M3 M4 (rZPlus n') (rZPlus m'));
 Auto.
Red; Apply rltTrans with y := n'; Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M'1 M'2 M'3 M'4 b' d'; Case b'; Intros H'0; Elim H'0; Intros H'4 H'5;
 Elim H'5; Intros H'6 H'7; Elim H'7; Intros H'8 H'9; Elim H'9; Intros H'10 H'11;
 Elim H'11; Intros H'12 H'13; Clear H'11 H'9 H'7 H'5 H'0; Auto.
Exists (((((M'1, M'2), M'3), M'4), true), d'); Repeat Split; Auto.
Apply stalmarckTrans with 1 := H'4; Auto.
Case (Rec (n', (rnext m'))) with M1 := M'1 M2 := M'2 M3 := M'3 M4 := M'4; Auto.
Red; Apply lexProd1; Auto.
Red; Split; Auto.
Apply rltTrans with y := (rnext n'); Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M''1 M''2 M''3 M''4 b'' d'' H'0; Elim H'0; Intros H'5 H'7; Elim H'7;
 Intros H'9 H'11; Elim H'11; Intros H'14 H'15; Elim H'15; Intros H'16 H'17;
 Elim H'17; Intros H'18 H'19; Try Exact H'19; Clear H'17 H'15 H'11 H'7 H'0.
Exists (((((M''1, M''2), M''3), M''4), b''), (appd maxN d' d'')); Repeat Split;
 Auto.
Apply stalmarckTrans with 1 := H'4; Auto.
Apply nEqAppd with M2 := M'1; Auto.
Apply inclStateTrans with S2 := (memF maxN M'1); Auto.
Apply (Rec ((rnext n'), (rnext zero))) with M1 := M1 M2 := M2 M3 := M3 M4 := M4;
 Auto.
Red; Apply lexProd2; Auto.
Red; Split; Auto.
Apply (Rec ((rnext n'), (rnext zero))) with M1 := M1 M2 := M2 M3 := M3 M4 := M4;
 Auto.
Red; Apply lexProd2; Auto.
Red; Split; Auto.
Exists (((((M1, M2), M3), M4), false), (dNil maxN)); Repeat Split; Auto.
Apply nEqRef; Auto.
Exists (((((M1, M2), M3), M4), false), (dNil maxN)); Repeat Split; Auto.
Apply nEqRef; Auto.
Qed.

Definition Sat2:
  (M1, M2, M3, M4:(Mem maxN))
  (eqMem maxN M1 M2) -> (eqMem maxN M1 M3) -> (eqMem maxN M1 M4) ->
  {R:((((Mem maxN) * (Mem maxN)) * (Mem maxN)) * (Mem maxN)) * bool | Cases R of
                                                                          (pair
                                                                             (pair
                                                                                (pair
                                                                                   (pair
                                                                                      M'1
                                                                                        M'2)
                                                                                     M'3)
                                                                                  M'4)
                                                                               b1)
                                                                            =>
                                                                            (stalmarckP
                                                                               (memF
                                                                                  maxN
                                                                                  M1)
                                                                               LL
                                                                               (memB
                                                                                  maxN
                                                                                  M'1
                                                                                  b1))
                                                                            /\
                                                                            ((eqMem
                                                                                maxN
                                                                                M'1
                                                                                M'2)
                                                                             /\
                                                                             ((eqMem
                                                                                 maxN
                                                                                 M'1
                                                                                 M'3)
                                                                              /\
                                                                              (eqMem
                                                                                 maxN
                                                                                 M'1
                                                                                 M'4)))
                                                                      end}.
Intros M1; Pattern M1; Apply well_founded_induction with R := (ltT maxN);
 Clear M1; Auto.
Apply ltTWf; Auto.
Intros M1 Rec.
Intros M2 M3 M4 H' H'0 H'1.
Case (Sat2Aux ((rnext zero), (rnext zero)) M1 M2 M3 M4); Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M'1 M'2 M'3 M'4 b' d'.
Case b'.
Intros H'2; Elim H'2; Intros H'3 H'4; Elim H'4; Intros H'5 H'6; Elim H'6;
 Intros H'7 H'8; Elim H'8; Intros H'9 H'10; Elim H'10; Intros H'11 H'12;
 Clear H'10 H'8 H'6 H'4 H'2.
Exists ((((M'1, M'2), M'3), M'4), true); Split; Auto.
Case (idDnilP maxN d').
Intros H'2 H'3; Elim H'3; Intros H'4 H'5; Elim H'5; Intros H'6 H'7; Elim H'7;
 Intros H'8 H'9; Elim H'9; Intros H'10 H'11; Elim H'11; Intros H'12 H'13;
 Clear H'11 H'9 H'7 H'5 H'3.
Cut (ltT maxN M'1 M1); [Intros lt0 | Idtac].
Case (Rec M'1 lt0 M'2 M'3 M'4); Auto.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros x; Case x; Clear x.
Intros M''1 M''2 M''3 M''4 b'' H'3; Elim H'3; Intros H'5 H'7; Elim H'7;
 Intros H'9 H'11; Elim H'11; Intros H'14 H'15; Clear H'11 H'7 H'3.
Exists ((((M''1, M''2), M''3), M''4), b''); Split; Auto.
Apply stalmarckrTrans with S2 := (memF maxN M'1); Auto.
Red; Auto.
Change (ltMem maxN M'1 M1).
Apply MemLtMem; Auto.
Intros H'2 H'3; Elim H'3; Intros H'4 H'5; Elim H'5; Intros H'6 H'7; Elim H'7;
 Intros H'8 H'9; Elim H'9; Intros H'10 H'11; Elim H'11; Intros H'12 H'13;
 Clear H'11 H'9 H'7 H'5 H'3.
Exists ((((M'1, M'2), M'3), M'4), false); Split; Auto.
Defined.
End algo.

