Require Import rZ.
Require Import PolyList.
Parameter Array:rNat -> Set ->Set.
Parameter genArray:(n:rNat) (A:Set) (f:(r:rNat) (rlt r n) ->A)(Array n A).
Parameter getAval:(n:rNat) (A:Set) (Ar:(Array n A)) (m:rNat) (rlt m n) ->A.
Parameter setAval:
          (n:rNat) (A:Set) (Ar:(Array n A)) (m:rNat) (rlt m n) -> A ->
          (Array n A).

Axiom getAvalIrr:
      (n:rNat)
      (A:Set)
      (Ar:(Array n A)) (m1, m2:rNat) (Hm1:(rlt m1 n)) (Hm2:(rlt m2 n)) m1=m2 ->
      (getAval n A Ar m1 Hm1)=(getAval n A Ar m2 Hm2).

Axiom setAvalIrr:
      (n:rNat)
      (A:Set)
      (Ar:(Array n A))
      (m1, m2:rNat) (Hm1:(rlt m1 n)) (Hm2:(rlt m2 n)) (v:A) m1=m2 ->
      (setAval n A Ar m1 Hm1 v)=(setAval n A Ar m2 Hm2 v).

Axiom setAvalDef1:
      (n:rNat) (A:Set) (Ar:(Array n A)) (m:rNat) (Hm:(rlt m n)) (v:A)
      (getAval n A (setAval n A Ar m Hm v) m Hm)=v.

Axiom setAvalDef2:
      (n:rNat)
      (A:Set)
      (Ar:(Array n A))
      (m1, m2:rNat) (Hm1:(rlt m1 n)) (Hm2:(rlt m2 n)) (v:A) ~ m1=m2 ->
      (getAval n A (setAval n A Ar m1 Hm1 v) m2 Hm2)=(getAval n A Ar m2 Hm2).
Parameter getSubset:(n:rNat) (A:Set) (Ar:(Array n A)) (test:A ->bool)(list rNat).

Axiom getSubsetIrr:
      (n:rNat)
      (A:Set)
      (test:A ->bool)
      (Ar1, Ar2:(Array n A))
      ((m:rNat) (Hm:(rlt m n))(getAval n A Ar1 m Hm)=(getAval n A Ar2 m Hm)) ->
      (getSubset n A Ar1 test)=(getSubset n A Ar2 test).

Axiom genArrayDef:
      (n:rNat)
      (A:Set)
      (m:rNat) (Hm:(rlt m n)) (f:(a:rNat) (rlt a n) ->A)
      (getAval n A (genArray n A f) m Hm)=(f m Hm).

Axiom getSubsetLe:
      (n:rNat)
      (A:Set)
      (Ar:(Array n A))
      (test:A ->bool) (r:rNat) (In r (getSubset n A Ar test)) ->(rlt r n).

Axiom getSubsetTestTrue:
      (n:rNat)
      (A:Set)
      (Ar:(Array n A))
      (test:A ->bool) (r:rNat) (Hr:(rlt r n)) (In r (getSubset n A Ar test)) ->
      (test (getAval n A Ar r Hr))=true.

Axiom getSubsetTestTrueRev:
      (n:rNat)
      (A:Set)
      (Ar:(Array n A))
      (test:A ->bool)
      (r:rNat) (Hr:(rlt r n)) (test (getAval n A Ar r Hr))=true ->
      (In r (getSubset n A Ar test)).

