Require Import rZ.
Require Import OrderedListEq.
Require Import LetP.
Require Import array.
Require Import Relation_Definitions.
Require Import state.
Require Import restrictState.
Require Import ltState.
Require Export memoryImplement.
Require Export addEqImplement2.
Require Export interImplement.
Section inter.
Variable LL:(list triplet).
Variable maxN:rNat.
Hypothesis HmaxN:maxN=(rnext (maxVarTriplets LL)).

Definition addInterAux:
  (d:(dList maxN)) (M1, M2, M3:(Mem maxN))
  {R:(Mem maxN) * (dList maxN) | Cases R of
                                     (pair M4 dL) =>
                                       (inclState (memF maxN M1) (memF maxN M2)) ->
                                       (inclState (memF maxN M1) (memF maxN M3)) ->
                                       (inclState (memF maxN M4) (memF maxN M2))
                                       /\
                                       ((inclState
                                           (memF maxN M4) (memF maxN M3)) /\
                                        ((inclState
                                            (memF maxN M1) (memF maxN M4)) /\
                                         ((eqExceptOn maxN M1 M4 dL) /\
                                          ((nEq maxN M1 M4 dL) /\
                                           ((a:rNat)
                                            (Ha:(rlt a maxN))
                                            (Ind maxN (rZPlus a) d) ->
                                            (eqStateRz
                                               (memF maxN M4) (rZPlus a)
                                               (getEquivMin maxN M2 M3 a Ha)))))))
                                 end}.
Intros d; Case d.
Intros L; Elim L.
Intros H' M1 M2 M3; Exists (M1, (dNil maxN)); Repeat Split; Auto.
Apply nEqRef; Auto.
Simpl; Auto.
Intros a Ha H'0; Inversion H'0; Auto.
Intros a l Rec H' M1 M2 M3.
Cut (OlistRz l) /\ ((a:rZ) (In a l) ->(rVlt a maxN));
 [Intros H'1 |
   Elim H'; Intros H'0 H'1; Clear H'; Split; Auto with datatypes;
    Apply OlistInv with 1 := H'0; Auto].
Case (Rec H'1 M1 M2 M3).
Intros rec; Case rec.
Intros M'1 dL1 HM'1.
Cut (rVlt a maxN); [Intros Ha | Elim H'; Auto with datatypes].
Cut (rVlt (getEquivMin maxN M2 M3 (valRz a) Ha) maxN);
 [Intros Hb | Apply getEquivMinMaxn with 1 := HmaxN; Auto].
Generalize (addEqMemProp28
              maxN M'1 (rZPlus (valRz a)) (getEquivMin maxN M2 M3 (valRz a) Ha)
              Ha Hb).
Generalize (addEqMemNEq
              maxN M'1 (rZPlus (valRz a)) (getEquivMin maxN M2 M3 (valRz a) Ha)
              Ha Hb).
Generalize (addEqMemProp18
              maxN M'1 (rZPlus (valRz a)) (getEquivMin maxN M2 M3 (valRz a) Ha)
              Ha Hb).
Generalize (addEqMemProp26
              maxN M'1 (rZPlus (valRz a)) (getEquivMin maxN M2 M3 (valRz a) Ha)
              Ha Hb).
Generalize (addEqMemProp2
              maxN M'1 (rZPlus (valRz a)) (getEquivMin maxN M2 M3 (valRz a) Ha)
              Ha Hb).
Case (addEqMem
        maxN M'1 (rZPlus (valRz a)) (getEquivMin maxN M2 M3 (valRz a) Ha) Ha Hb).
Intros p; Case p; Clear p.
Intros M''1 b dL2 Hp1 Hp2 Hp3 Hp4 Hp5; Exists (M''1, (appd maxN dL1 dL2));
 Repeat Split; Auto; Elim (HM'1 H H0); Intros Pr1 Pr2; Elim Pr2; Clear Pr2;
 Intros Pr2 Pr3; Elim Pr3; Clear Pr3; Intros Pr3 Pr4; Elim Pr4; Clear Pr4;
 Intros Pr4 Pr5; Elim Pr5; Clear Pr5; Intros Pr5 PR6.
Generalize Hp1 Hp2; Clear Hp1 Hp2; Case b; Auto.
Intros H'2; Elim H'2; Intros H'4 H'7; Rewrite <- H'4; Clear H'2; Auto.
Intros H'2 H'3.
Apply inclStateEqStateComp with 1 := H'3 S3 := (memF maxN M2); Auto.
Apply inclStateAddEqInv; Auto.
Apply getEquivMinEq1 with 1 := HmaxN; Auto.
Generalize Hp1 Hp2; Clear Hp1 Hp2; Case b; Auto.
Intros H'2; Elim H'2; Intros H'4 H'7; Rewrite <- H'4; Clear H'2; Auto.
Intros H'2 H'3.
Apply inclStateEqStateComp with 1 := H'3 S3 := (memF maxN M3); Auto.
Apply inclStateAddEqInv; Auto.
Apply getEquivMinEq2 with 1 := HmaxN; Auto.
Generalize Hp1 Hp2; Clear Hp1 Hp2; Case b; Auto.
Intros H'2; Elim H'2; Intros H'4 H'7; Rewrite <- H'4; Clear H'2; Auto.
Intros H'2 H'4.
Apply inclStateTrans with S2 := (memF maxN M'1); Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M'1) 2 := H'4; Auto.
Apply eqExceptOnAppd with M2 := M'1; Auto.
Generalize Hp1 Hp2; Clear Hp1 Hp2; Case b; Auto.
Intros H'2; Elim H'2; Intros H'4 H'6; Rewrite <- H'4; Clear H'2; Auto.
Intros H'2; Apply eqExceptOnRef; Auto.
Apply eqMemRef; Auto.
Intros H'2 H'4.
Apply eqExceptOnSym; Auto.
Apply nEqAppd with M2 := M'1; Auto.
Generalize Hp1 Hp2; Clear Hp1 Hp2; Case b; Auto.
Intros H'2; Elim H'2; Intros H'4 H'7; Rewrite <- H'4; Clear H'2; Auto.
Intros H'2 H'4.
Apply inclStateEqStateComp with S1 := (memF maxN M'1) 2 := H'4; Auto.
Simpl in Hp4; Auto.
Generalize Hp1 Hp2 Hp5; Case b; Auto.
Intros H'2; Elim H'2; Intros H'4 H'6; Rewrite <- H'4; Clear H'2; Auto.
Intros H'0 H'2 a0 Ha0 H'3.
Absurd (contradictory (memF maxN M2)); Auto.
Apply memFNotContradictory; Auto.
Red; Auto.
Exists (rZPlus (valRz a)).
Apply eqStateContr
     with p := (rZPlus (valRz a)) q := (getEquivMin maxN M2 M3 (valRz a) Ha);
 Auto.
Apply getEquivMinEq1 with 1 := HmaxN; Auto.
Apply eqStateIncl with S1 := (memF maxN M'1); Auto.
Apply evalInvComp with 1 := H'2; Auto.
Intros H'0 H'2 H'3 a0 Ha0 H'4; Inversion H'4; Auto.
Red in H3; Simpl in H3; Auto.
Pattern 1 a0; Rewrite H3; Auto.
Generalize (getRzMinUnique
              LL maxN HmaxN M2 M3 (rZPlus a0) (rZPlus (valRz a)) Ha0 Ha); Simpl;
 Auto.
Intros H'5; Rewrite H'5; Auto.
Apply eqStateEq with 1 := H'2; Auto.
Rewrite H3; Auto.
Rewrite H3; Auto.
Apply eqStateIncl with S1 := (memF maxN M'1); Auto.
Apply inclStateEqStateComp with S1 := (memF maxN M'1) 2 := H'2; Auto.
Qed.

Definition interd: (dL1, dL2:(dList maxN))(dList maxN).
Intros dL1; Case dL1; Intros L1 HL1.
Intros dL2; Case dL2; Intros L2 HL2.
Exists (interf ? rZlt eqRz rZltDec L1 L2).
Elim HL1; Intros H' H'0; Clear HL1.
Elim HL2; Intros H'1 H'2; Clear HL2.
Split; Auto.
Red; Apply interfOlist; Auto.
Try Exact rZltEqComp.
Intros a H'3.
Cut (InEq ? eqRz a L1); Auto.
Intros H'4; Generalize H'0.
Elim H'4; Auto with datatypes.
Intros a0 b L H'5 H'6; Red; Auto.
Red in H'5; Rewrite H'5; Change (rVlt b maxN); Auto with datatypes.
LApply (interfIncl1 ? rZlt eqRz);
 [Intros H'7; LApply H'7;
   [Intros H'8; LApply H'8;
     [Intros H'9; Specialize 3 H'9 with ltADec := rZltDec L1 := L1 L2 := L2;
       Intros H'12; Clear H'8 H'7 | Clear H'8 H'7] | Clear H'7] | Idtac]; Auto.
Inversion H'12; Auto.
Apply H; Auto.
Apply inImpInEq; Auto.
Defined.

Definition interMem :=
   [M1, M2, M3:(Mem maxN)] [dL1, dL2:(dList maxN)]
      Cases (addInterAux (interd dL1 dL2) M1 M2 M3) of
          (exist x _) => x
      end.

Definition interMemProp1:
  (M1, M2, M3:(Mem maxN))
  (dL1, dL2:(dList maxN))
  (inclState (memF maxN M1) (memF maxN M2)) ->
  (inclState (memF maxN M1) (memF maxN M3)) ->
  (inclState (memF maxN (Fst (interMem M1 M2 M3 dL1 dL2))) (memF maxN M2)).
Intros M1 M2 M3 dL1 dL2 H' H'0; Unfold interMem;
 Case (addInterAux (interd dL1 dL2) M1 M2 M3); Intuition.
Qed.

Definition interMemProp2:
  (M1, M2, M3:(Mem maxN))
  (dL1, dL2:(dList maxN))
  (inclState (memF maxN M1) (memF maxN M2)) ->
  (inclState (memF maxN M1) (memF maxN M3)) ->
  (inclState (memF maxN (Fst (interMem M1 M2 M3 dL1 dL2))) (memF maxN M3)).
Intros M1 M2 M3 dL1 dL2 H' H'0; Unfold interMem;
 Case (addInterAux (interd dL1 dL2) M1 M2 M3); Intuition.
Qed.

Definition interMemProp3:
  (M1, M2, M3:(Mem maxN))
  (dL1, dL2:(dList maxN))
  (inclState (memF maxN M1) (memF maxN M2)) ->
  (inclState (memF maxN M1) (memF maxN M3)) ->
  (inclState (memF maxN M1) (memF maxN (Fst (interMem M1 M2 M3 dL1 dL2)))).
Intros M1 M2 M3 dL1 dL2 H' H'0; Unfold interMem;
 Case (addInterAux (interd dL1 dL2) M1 M2 M3); Intuition.
Qed.

Definition interMemProp4:
  (M1, M2, M3:(Mem maxN))
  (dL1, dL2:(dList maxN))
  (inclState (memF maxN M1) (memF maxN M2)) ->
  (inclState (memF maxN M1) (memF maxN M3)) ->
  (eqExceptOn
     maxN M1 (Fst (interMem M1 M2 M3 dL1 dL2)) (Snd (interMem M1 M2 M3 dL1 dL2))).
Intros M1 M2 M3 dL1 dL2 H' H'0; Unfold interMem;
 Case (addInterAux (interd dL1 dL2) M1 M2 M3); Intuition.
Qed.

Definition interMemProp5:
  (M1, M2, M3:(Mem maxN))
  (dL1, dL2:(dList maxN))
  (inclState (memF maxN M1) (memF maxN M2)) ->
  (inclState (memF maxN M1) (memF maxN M3)) ->
  (nEq
     maxN M1 (Fst (interMem M1 M2 M3 dL1 dL2)) (Snd (interMem M1 M2 M3 dL1 dL2))).
Intros M1 M2 M3 dL1 dL2 H' H'0; Unfold interMem;
 Case (addInterAux (interd dL1 dL2) M1 M2 M3); Intuition.
Qed.

Definition interMemProp6:
  (M1, M2, M3:(Mem maxN))
  (dL1, dL2:(dList maxN))
  (inclState (memF maxN M1) (memF maxN M2)) ->
  (inclState (memF maxN M1) (memF maxN M3)) ->
  (a:rNat) (Ha:(rlt a maxN)) (Ind maxN (rZPlus a) (interd dL1 dL2)) ->
  (eqStateRz
     (memF maxN (Fst (interMem M1 M2 M3 dL1 dL2))) (rZPlus a)
     (getEquivMin maxN M2 M3 a Ha)).
Intros M1 M2 M3 dL1 dL2 H' H'0; Unfold interMem;
 Case (addInterAux (interd dL1 dL2) M1 M2 M3); Intuition.
Qed.

Definition getListd: (dList maxN) ->(list rZ) :=
   [H':(dList maxN)]
      Cases H' of
          (exist x _) => x
      end.

Theorem eMZevalMzEq:
  (M1, M2:(Mem maxN))
  (a:rNat) (Ha:(rlt a maxN)) (eMZ maxN M1 a Ha)=(eMZ maxN M2 a Ha) ->
  (evalMZ maxN M1 (rZPlus a) Ha)=(evalMZ maxN M2 (rZPlus a) Ha).
Intros M1 M2 a Ha; Case M1; Case M2; Simpl; Auto.
Intros Ar2 War2 Ar1 War1.
Case (getAval maxN vM Ar1 a Ha); Case (getAval maxN vM Ar2 a Ha);
 Intros r0 r1 H1; Try Discriminate; Inversion H1; Auto.
Qed.

Definition interMemProp7:
  (M1, M2, M3:(Mem maxN))
  (dL1, dL2:(dList maxN))
  (inclState (memF maxN M1) (memF maxN M2)) ->
  (inclState (memF maxN M1) (memF maxN M3)) ->
  (eqExceptOn maxN M1 M2 dL1) -> (eqExceptOn maxN M1 M3 dL2) ->
  (a:rNat) (Ha:(rlt a maxN))
  (eqStateRz
     (memF maxN (Fst (interMem M1 M2 M3 dL1 dL2))) (rZPlus a)
     (getEquivMin maxN M2 M3 a Ha)).
Intros M1 M2 M3 dL1 dL2 H' H'0 H'1 H'2 a Ha.
Case (InRzDec (rZPlus a) (getListd dL1)); Intros In1.
Case (InRzDec (rZPlus a) (getListd dL2)); Intros In1.
Apply interMemProp6; Auto.
Generalize In0 In1; Unfold interd getListd; Case dL1; Case dL2; Simpl; Auto.
Intros x H'3 x0 H'4 H'5 H'6; Red; Auto.
Cut (InclEq ? eqRz (cons (rZPlus a) (nil ?)) (interf rZ rZlt eqRz rZltDec x0 x));
 Auto.
Intros H'7; Inversion H'7.
Apply H; Apply InEqHead; Auto.
Apply interfMin; Auto.
Try Exact rZltEqComp.
Elim H'4; Auto.
Elim H'3; Auto.
Apply OlistOne; Auto.
Apply InclEqDef; Auto.
Intros a0 H'7; Inversion H'7; Auto.
Generalize H1; Elim H'6; Auto.
Intros a2 b0 L0 H'8 H'9.
Apply InEqHead; Auto.
Apply eqrZTrans with y := a2; Auto.
Intros a2 b0 L0 H'8 H'9 H'10.
Apply InEqSkip; Auto.
Inversion H1; Auto.
Apply InclEqDef; Auto.
Intros a0 H'7; Inversion H'7; Auto.
Generalize H1; Elim H'5; Auto.
Intros a2 b0 L0 H'8 H'9.
Apply InEqHead; Auto.
Apply eqrZTrans with y := a2; Auto.
Intros a2 b0 L0 H'8 H'9 H'10.
Apply InEqSkip; Auto.
Inversion H1; Auto.
Rewrite getEquivIdL with 1 := HmaxN; Auto.
Apply eqStateIncl with S1 := (memF maxN M1); Auto.
Apply interMemProp3; Auto.
Rewrite <- (eMZevalMzEq M1 M3); Auto.
Apply evalEq; Auto.
Red in H'2.
Apply H'2; Auto.
Generalize In0; Case dL2; Auto.
Apply eqStateIncl with S1 := (memF maxN M1); Auto.
Rewrite <- (eMZevalMzEq M1 M3); Auto.
Apply evalEq; Auto.
Red in H'2.
Apply H'2; Auto.
Generalize In0; Case dL2; Auto.
Rewrite getEquivIdR with 1 := HmaxN; Auto.
Apply eqStateIncl with S1 := (memF maxN M1); Auto.
Apply interMemProp3; Auto.
Rewrite <- (eMZevalMzEq M1 M2); Auto.
Apply evalEq; Auto.
Red in H'1.
Apply H'1; Auto.
Generalize In1; Case dL1; Auto.
Apply eqStateIncl with S1 := (memF maxN M1); Auto.
Rewrite <- (eMZevalMzEq M1 M2); Auto.
Apply evalEq; Auto.
Red in H'1.
Apply H'1; Auto.
Generalize In1; Case dL1; Auto.
Qed.

Definition interMemProp8:
  (M1, M2, M3:(Mem maxN))
  (dL1, dL2:(dList maxN))
  (inclState (memF maxN M1) (memF maxN M2)) ->
  (inclState (memF maxN M1) (memF maxN M3)) ->
  (eqExceptOn maxN M1 M2 dL1) -> (eqExceptOn maxN M1 M3 dL2) ->
  (eqState
     (interState (memF maxN M2) (memF maxN M3))
     (memF maxN (Fst (interMem M1 M2 M3 dL1 dL2)))).
Intros M1 M2 M3 dL1 dL2 H' H'0 H'1 H'2; Red; Split; Auto.
Apply getEquivInter with 1 := HmaxN; Auto.
Intros a Ha.
Apply interMemProp7; Auto.
Apply interMemMin; Auto.
Apply interMemProp1; Auto.
Apply interMemProp2; Auto.
Qed.
End inter.
