Require Import rZ.
Require Import OrderedListEq.
Require Import Relation_Definitions.
Require Import LetP.
Require Import PolyListAux.
Require Import PolyList.
Require Import array.
Require Import triplet.
Require Import state.
Require Import restrictState.
Require Import ltState.
Require Import Option.
Require Import memoryImplement.
Section mem.
Variable LL:(list triplet).
Variable maxN:rNat.
Hypothesis HmaxN:maxN=(rnext (maxVarTriplets LL)).

Definition initMem: (Mem maxN).
Exists (genArray maxN ? [_:?] [_:?](class (nil ?))).
Apply wellFormedArrayDef; Auto.
Apply pointerDecreaseDef; Auto.
Intros r s Hr; Rewrite genArrayDef.
Intros; Discriminate.
Apply pointToClassRefDef; Auto.
Intros r s t Hr Hs; Rewrite genArrayDef; Auto.
Intros; Discriminate.
Apply pointToClassClassRef; Auto.
Intros r s Hr Hs Lr; Rewrite genArrayDef; Auto.
Intros H'; Inversion H'; Auto.
Intros H'1; Inversion H'1.
Intros r s Hr Hs Ls; Rewrite genArrayDef; Auto.
Intros; Discriminate.
Apply classInArrrayDef; Auto.
Intros r s Hr Lr; Rewrite genArrayDef; Auto.
Intros H'; Inversion H'; Auto.
Intros H'1; Inversion H'1.
Apply OlistArrayDef; Auto.
Intros r Hr Lr; Rewrite genArrayDef; Auto.
Intros H'; Inversion H'; Auto.
Red; Auto.
Apply OlistNil; Auto.
Defined.

Theorem initMemEMz:
  (a:rNat) (Ha:(rlt a maxN))(eMZ maxN initMem a Ha)=(class (nil ?)).
Intros a Ha; Unfold initMem; Simpl; Auto.
Rewrite genArrayDef; Auto.
Qed.

Theorem initMemMemF: (eqState (memF maxN initMem) (nil ?)).
Red; Split; Auto.
Apply inclStateIn; Auto.
Intros a b H'.
Case memFProp1 with 1 := H'; Auto.
Intros H'0 H'1; Specialize 1 H'1 with Maxa := H'0.
Generalize H'0; Case a; Unfold initMem; Simpl; Auto.
Intros r H'0.
Rewrite (genArrayDef maxN vM r H'2) with f :=
                                         [a:rNat] [Ha:(rlt a maxN)]
                                         (class (nil rZ)); Auto.
Intros H'3; Rewrite H'3; Auto.
Intros r H'0.
Rewrite (genArrayDef maxN vM r H'2) with f :=
                                         [a:rNat] [Ha:(rlt a maxN)]
                                         (class (nil rZ)); Auto.
Intros H'3; Rewrite H'3; Auto.
Apply inclStateIn; Auto.
Intros a b H'; Inversion H'; Auto.
Qed.

Definition initCopyMem: (Mem maxN) ->(Mem maxN).
Intros M1; Case M1.
Intros Ar1 War1;
 Exists (genArray maxN ? [a:rNat] [Ha:(rlt a maxN)](getAval maxN ? Ar1 a Ha)).
Apply WarCompEq with Ar1 := Ar1; Auto.
Intros a Ha; Rewrite genArrayDef; Auto.
Defined.

Theorem initCopyMemEq: (M1:(Mem maxN))(eqMem maxN M1 (initCopyMem M1)).
Intros M1; Red; Auto.
Intros a Maxa; Case M1; Simpl; Auto.
Intros Ar War; Rewrite genArrayDef; Auto.
Qed.
End mem.

