Require Import Option.
Require Import stalmarck.
Require Import restrictState.

Definition getFrontier:
  (a:rZ) (S:State) (L:(list triplet)){ob:(Option rZ) | Cases ob of
                                                           (Some b) =>
                                                             (eqStateRz S a b)
                                                             /\
                                                             (In
                                                                (valRz b)
                                                                (ResTriplets L))
                                                          | None =>
                                                              (b:rZ)
                                                              (In
                                                                 (valRz b)
                                                                 (ResTriplets L)) ->
                                                              ~ (eqStateRz
                                                                   S a b)
                                                       end}.
Intros a S L; Elim L; Simpl.
Case (eqStateRzDec S a (rZPlus zero)).
Intros H'; Exists (Some rZ (rZPlus zero)); Auto.
Case (eqStateRzDec S a (rZMinus zero)).
Intros H' H'0; Exists (Some rZ (rZMinus zero)); Auto.
Intros H' H'0; Exists (None rZ); Auto.
Intros b; Case b; Auto.
Intros r H'1; Elim H'1;
 [Intros H'2; Clear H'1 | Intros H'2; Elim H'2; Clear H'1].
Red; Intros H'1; Apply H'0; Rewrite H'2; Simpl; Auto.
Intros r H'1; Elim H'1;
 [Intros H'2; Clear H'1 | Intros H'2; Elim H'2; Clear H'1].
Red; Intros H'1; Apply H'; Rewrite H'2; Simpl; Auto.
Intros a0 l H'; Case H'; Auto.
Intros x; Case x.
Intros b H'0; Exists (Some rZ b).
Intuition; Auto.
Intros H'0; Case a0; Simpl.
Intros H'1 p q r.
Case (eqStateRzDec S a p); Intros Eqp; [Exists (Some ? p) | Idtac]; Auto.
Case (eqStateRzDec S a (rZComp p)); Intros Eqmp;
 [Exists (Some ? (rZComp p)); Split; Auto; Case p | Idtac]; Simpl; Auto.
Case (eqStateRzDec S a q); Intros Eqq; [Exists (Some ? q) | Idtac]; Auto.
Case (eqStateRzDec S a (rZComp q)); Intros Eqmq;
 [Exists (Some ? (rZComp q)); Split; Auto; Case q | Idtac]; Simpl; Auto.
Case (eqStateRzDec S a r); Intros Eqr; [Exists (Some ? r) | Idtac]; Auto.
Case (eqStateRzDec S a (rZComp r)); Intros Eqmr;
 [Exists (Some ? (rZComp r)); Split; Auto; Case r | Idtac]; Simpl; Auto.
Exists (None rZ); Auto.
Intros b; Case b;
 (Intros r0 H'2; Elim H'2; Clear H'2; Intros H'2;
   [Idtac |
     Elim H'2; Clear H'2; Intros H'2;
      [Idtac |
        Elim H'2; Clear H'2; Intros H'2;
         [Idtac | Elim H'2; Clear H'2; Intros H'2; Idtac]]]); Simpl in H'2;
 Auto; Rewrite <- H'2.
Generalize Eqp Eqmp; Case p; Auto.
Generalize Eqq Eqmq; Case q; Auto.
Generalize Eqr Eqmr; Case r; Auto.
Apply H'0; Auto; Simpl; Apply zeroInL; Auto.
Generalize Eqp Eqmp; Case p; Auto.
Generalize Eqq Eqmq; Case q; Auto.
Generalize Eqr Eqmr; Case r; Auto.
Apply H'0; Auto; Simpl; Apply zeroInL; Auto.
Defined.

Definition getAlternativePair:
  (a, b:rZ) (S:State) (L:(list triplet)){op:(Option rZ * rZ) | Cases op of
                                                                   (Some
                                                                      (pair
                                                                         a' b'))
                                                                     =>
                                                                     (((In
                                                                          (valRz
                                                                             a')
                                                                          (ResTriplets
                                                                             L))
                                                                       /\
                                                                       (In
                                                                          (valRz
                                                                             b')
                                                                          (ResTriplets
                                                                             L)))
                                                                      /\
                                                                      (eqState
                                                                         (addEq
                                                                            (a,
                                                                             (rZComp
                                                                                b))
                                                                            S)
                                                                         (addEq
                                                                            (a',
                                                                             (rZComp
                                                                                b'))
                                                                            S)))
                                                                     /\
                                                                     (eqState
                                                                        (addEq
                                                                           (a,
                                                                            b) S)
                                                                        (addEq
                                                                           (a',
                                                                            b')
                                                                           S))
                                                                  | None =>
                                                                      (eqState
                                                                         (restrictState
                                                                            (addEq
                                                                               (a,
                                                                                b)
                                                                               S)
                                                                            (ResTriplets
                                                                               L))
                                                                         (restrictState
                                                                            S
                                                                            (ResTriplets
                                                                               L)))
                                                                      /\
                                                                      (eqState
                                                                         (restrictState
                                                                            (addEq
                                                                               (a,
                                                                                (rZComp
                                                                                   b))
                                                                               S)
                                                                            (ResTriplets
                                                                               L))
                                                                         (restrictState
                                                                            S
                                                                            (ResTriplets
                                                                               L)))
                                                               end}.
Intros a b S L.
Case (eqStateRzDec S a b); Intros Eqab0;
 [Exists (Some ? ((rZPlus zero), (rZPlus zero))) | Idtac]; Auto.
Repeat Split; Auto; Red; Auto.
Intros i j H'; Apply eqStateRzContr with a := (rZPlus zero); Auto.
Intros i j H'; Apply eqStateRzContr with a := a; Auto.
Apply eqStateRzTrans with b := (rZComp b); Auto.
Case (eqStateRzDec S a (rZComp b)); Intros Eqab1;
 [Exists (Some ? ((rZPlus zero), (rZMinus zero))) | Idtac]; Auto.
Repeat Split; Auto; Red; Auto.
Intros i j H'; Apply eqStateRzContr with a := (rZPlus zero); Auto.
Intros i j H'; Apply eqStateRzContr with a := a; Auto.
Apply eqStateRzTrans with b := (rZComp b); Auto.
Case (getFrontier a S L).
Intros x; Case x; Clear x.
Intros a' H'; Elim H'; Intros Ha1 Ha2; Clear H'.
Case (getFrontier b S L).
Intros x; Case x; Clear x.
Intros b' H'; Elim H'; Intros Hb1 Hb2; Clear H'.
Exists (Some ? (a', b')).
Split; Auto.
Intros H'; Exists (None rZ * rZ).
Split; Red; Split; Auto.
2:Apply restricMonotone; Auto with datatypes.
Red; Intros i j H'0; Auto.
Case (rZDec i j); Intros Eqij.
Rewrite <- Eqij; Auto.
Elim (InRestrictState (addEq (a, b) S) (ResTriplets L) i j);
 [Intros Ini Inj | Idtac | Idtac | Idtac]; Auto.
Cut (eqConstrState (addEq (a, b) S) i j).
Unfold addEq; Intros H'1; Inversion H'1.
Apply restrictStateComp; Auto.
LApply (H' j); [Intros H'3; Case H'3 | Idtac]; Auto.
LApply (H' i); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
LApply (H' (rZComp j)); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Apply eqStateContrSimpl1; Auto.
Apply eqStateRzSym; Auto.
Generalize Inj; Case j; Simpl; Auto.
LApply (H' (rZComp i)); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Generalize Ini; Case i; Simpl; Auto.
LApply (H' (rZComp i)); [Intros H'3; Case H'3 | Idtac]; Auto.
Case Eqab1; Auto.
Generalize Ini; Case i; Simpl; Auto.
Apply eqStateRzPImpeqConstrState.
Apply eqStateIncl with S1 := (restrictState (addEq (a, b) S) (ResTriplets L));
 Auto.
Apply restrictStateIncl; Auto.
2:Apply restricMonotone; Auto with datatypes.
Red; Intros i j H'0; Auto.
Case (rZDec i j); Intros Eqij.
Rewrite <- Eqij; Auto.
Elim (InRestrictState (addEq (a, (rZComp b)) S) (ResTriplets L) i j);
 [Intros Ini Inj | Idtac | Idtac | Idtac]; Auto.
Cut (eqConstrState (addEq (a, (rZComp b)) S) i j).
Unfold addEq; Intros H'1; Inversion H'1.
Apply restrictStateComp; Auto.
LApply (H' (rZComp j)); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Apply eqStateContrSimpl1; Auto.
Apply eqStateRzSym; Auto.
Generalize Inj; Case j; Simpl; Auto.
LApply (H' (rZComp i)); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Generalize Ini; Case i; Simpl; Auto.
Rewrite (rZCompInv b) in H5.
LApply (H' j); [Intros H'3; Case H'3 | Idtac]; Auto.
Rewrite (rZCompInv b) in H4.
LApply (H' i); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Rewrite (rZCompInv b) in H4.
Case Eqab0; Auto.
Apply eqStateRzPImpeqConstrState.
Apply eqStateIncl
     with S1 := (restrictState (addEq (a, (rZComp b)) S) (ResTriplets L)); Auto.
Apply restrictStateIncl; Auto.
Red; Intros H'1; Case Eqab0.
Rewrite <- (rZCompInv b).
Apply contradictoryAddEq; Auto.
Intros H'; Exists (None rZ * rZ).
Split; Red; Split; Auto.
2:Apply restricMonotone; Auto with datatypes.
Red; Intros i j H'0.
Case (rZDec i j); Intros Eqij.
Rewrite <- Eqij; Auto.
Elim (InRestrictState (addEq (a, b) S) (ResTriplets L) i j);
 [Intros Ini Inj | Idtac | Idtac | Idtac]; Auto.
Cut (eqConstrState (addEq (a, b) S) i j).
Unfold addEq; Intros H'1; Inversion H'1.
Apply restrictStateComp; Auto.
LApply (H' i); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
LApply (H' j); [Intros H'3; Case H'3 | Idtac]; Auto.
LApply (H' (rZComp i)); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Generalize Ini; Case i; Simpl; Auto.
LApply (H' (rZComp j)); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Apply eqStateContrSimpl1; Auto.
Apply eqStateRzSym; Auto.
Generalize Inj; Case j; Simpl; Auto.
Case Eqab1; Auto.
Apply eqStateRzPImpeqConstrState.
Apply eqStateIncl with S1 := (restrictState (addEq (a, b) S) (ResTriplets L));
 Auto.
Apply restrictStateIncl; Auto.
2:Apply restricMonotone; Auto with datatypes.
Red; Intros i j H'0.
Case (rZDec i j); Intros Eqij.
Rewrite <- Eqij; Auto.
Elim (InRestrictState (addEq (a, (rZComp b)) S) (ResTriplets L) i j);
 [Intros Ini Inj | Idtac | Idtac | Idtac]; Auto.
Cut (eqConstrState (addEq (a, (rZComp b)) S) i j).
Unfold addEq; Intros H'1; Inversion H'1.
Apply restrictStateComp; Auto.
LApply (H' i); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
LApply (H' j); [Intros H'3; Case H'3 | Idtac]; Auto.
LApply (H' (rZComp i)); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Generalize Ini; Case i; Simpl; Auto.
LApply (H' (rZComp j)); [Intros H'3; Case H'3 | Idtac]; Auto.
Apply eqStateRzSym; Auto.
Apply eqStateContrSimpl1; Auto.
Apply eqStateRzSym; Auto.
Generalize Inj; Case j; Simpl; Auto.
Rewrite (rZCompInv b) in H4.
Case Eqab0; Auto.
Apply eqStateRzPImpeqConstrState.
Apply eqStateIncl
     with S1 := (restrictState (addEq (a, (rZComp b)) S) (ResTriplets L)); Auto.
Apply restrictStateIncl; Auto.
Red; Intros H'1; Case Eqab0; Auto.
Rewrite <- (rZCompInv b).
Apply contradictoryAddEq; Auto.
Qed.

Mutual Inductive dilemmaP': State -> (list triplet) -> State ->Prop :=
     dilemmaP'Ref:
       (S1, S2:State) (L:(list triplet)) (doTripletsP S1 L S2) ->
       (dilemmaP' S1 L S2)
    | dilemmaP'Split:
        (a, b:rZ)
        (S1, S2, S3, S4:State)
        (L:(list triplet))
        (In (valRz a) (ResTriplets L)) ->
        (In (valRz b) (ResTriplets L)) ->
        (dilemmaP' (addEq (a, b) S1) L S2) ->
        (dilemmaP' (addEq (a, (rZComp b)) S1) L S3) ->
        (eqState (interState S2 S3) S4) ->(dilemmaP' S1 L S4) .

Theorem dilemmaP'ImpdilemmaP:
  (S1, S2:State) (L:(list triplet)) (dilemmaP' S1 L S2) ->(dilemmaP S1 L S2).
Intros S1 S2 L H'; Elim H'; Auto.
Intros a b S3 S4 S5 S6 L0 H'0 H'1 H'2 H'3 H'4 H'5 H'6.
Apply dilemmaPSplit with a := a b := b S2 := S4 S3 := S5; Auto.
Qed.

Theorem restrictInter:
  (S1, S2:State) (L:(list rNat))
  (eqState
     (restrictState (interState S1 S2) L)
     (interState (restrictState S1 L) (restrictState S2 L))).
Intros S1 S2 L; Red; Split; Auto.
Apply interMemMin; Auto.
Apply restricMonotone; Auto with datatypes.
Apply restricMonotone; Auto with datatypes.
Red.
Intros i j H'.
Case (rZDec i j); Intros H'0; Auto.
Rewrite H'0; Auto.
Case (eqStateRzContrDec S1); Auto; Intros H'1.
Case (eqStateRzContrDec S2); Auto; Intros H'2.
Unfold restrictState.
Case (eqStateRzContrDec (interState S1 S2)); Auto.
Intros H'3.
Apply eqStateRzContr with a := rZTrue; Auto.
Intros H'3; Case H'3; Auto.
Intros a b.
Apply interMemEqStateRz; Auto.
Elim (InRestrictState S2 L i j); [Intros H'10 H'11 | Idtac | Idtac | Idtac];
 Auto.
Apply restrictStateComp; Auto.
Apply interMemEqStateRz; Auto.
Apply eqStateIncl with S1 := (restrictState S2 L); Auto.
Apply restrictStateIncl; Auto.
Apply eqStateIncl
     with S1 := (interState (restrictState S1 L) (restrictState S2 L)); Auto.
Apply eqStateIncl
     with S1 := (interState (restrictState S1 L) (restrictState S2 L)); Auto.
Red; Intros H'3; Red in H'3; Auto.
Elim H'3; Intros a E; Clear H'3.
Case H'2; Intros a0 b.
Apply eqStateRzContr with a := a; Auto.
Elim (InRestrictState S1 L i j); [Intros H'9 H'10 | Idtac | Idtac | Idtac]; Auto.
Apply restrictStateComp; Auto.
Apply interMemEqStateRz; Auto.
Apply eqStateIncl with S1 := (restrictState S1 L); Auto.
Apply restrictStateIncl; Auto.
Apply eqStateIncl
     with S1 := (interState (restrictState S1 L) (restrictState S2 L)); Auto.
Apply eqStateIncl with S1 := (restrictState S2 L); Auto.
Apply restrictStateIncl; Auto.
Apply eqStateIncl
     with S1 := (interState (restrictState S1 L) (restrictState S2 L)); Auto.
Apply eqStateIncl
     with S1 := (interState (restrictState S1 L) (restrictState S2 L)); Auto.
Red; Intros H'3; Red in H'3; Auto.
Elim H'3; Intros a E; Clear H'3.
Case H'1; Intros a0 b.
Apply eqStateRzContr with a := a; Auto.
Qed.

Theorem restrictAddIn:
  (a, b:rZ) (S:State) (L:(list rNat)) (In (valRz a) L) -> (In (valRz b) L) ->
  (eqState
     (restrictState (addEq (a, b) S) L) (addEq (a, b) (restrictState S L))).
Intros a b S L H' H'0; Red; Split; Auto.
Red; Auto.
Intros i j H'1.
Case (rZDec i j); Intros H'2; Auto.
Rewrite <- H'2; Auto.
2:Apply inclStateIn; Simpl; Auto.
2:Intros a0 b0 H'1; Elim H'1;
   [Intros H'2; Inversion H'2; Clear H'1 | Intros H'2; Clear H'1]; Auto.
2:Apply restrictStateComp; Auto.
2:Rewrite <- H0; Auto.
2:Rewrite <- H1; Auto.
2:Apply eqStateIncl with S1 := (restrictState S L); Auto.
2:Apply restricMonotone; Auto with datatypes.
Case (eqStateRzContrDec (addEq (a, b) S)); Intros Contr0; Auto.
Apply eqStateRzContr with a := a; Auto.
Apply eqStateRzTrans with b := b; Auto.
Apply eqStateRzSym.
Apply eqStateContrSimpl1.
Apply eqStateIncl with S1 := (restrictState S L); Auto.
Apply restrictStateComp; Auto.
Generalize H'0; Case b; Simpl; Auto.
Apply contradictoryAddEq; Auto.
Red; Exists i; Auto.
Elim (InRestrictState (addEq (a, b) S) L i j);
 [Intros H'10 H'11 | Idtac | Idtac | Idtac]; Auto.
2:Red; Intros H'3; Red in H'3.
2:Elim H'3; Intros a0 E; Clear H'3.
2:Case Contr0; Intros a1 b0.
2:Apply eqStateRzContr with a := a0; Auto.
Cut (eqConstrState (addEq (a, b) S) i j); Auto.
Intros H'3; Unfold addEq in H'3; Inversion H'3.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Apply eqStateRzTrans with b := a; Auto.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Apply eqStateRzTrans with b := b; Auto.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Apply eqStateRzTrans with b := b; Auto.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Apply eqStateRzTrans with b := a; Auto.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Apply eqStateRzTrans with b := (rZComp a); Auto.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Generalize H'; Case a; Simpl; Auto.
Apply eqStateRzTrans with b := (rZComp b); Auto.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Generalize H'0; Case b; Simpl; Auto.
Apply eqStateRzTrans with b := (rZComp b); Auto.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Generalize H'0; Case b; Simpl; Auto.
Apply eqStateRzTrans with b := (rZComp a); Auto.
Unfold addEq; Apply eqStateRzTail; Auto.
Apply restrictStateComp; Auto.
Generalize H'; Case a; Simpl; Auto.
Case Contr0; Intros a1 b1.
Apply eqStateContr with p := a q := b; Auto.
Apply eqStateRzPImpeqConstrState.
Apply eqStateIncl with S1 := (restrictState (addEq (a, b) S) L); Auto.
Apply restrictStateIncl; Auto.
Qed.

Theorem dilemmaP'Restrict:
  (S1, S2:State)
  (L:(list triplet))
  (dilemmaP' S1 L S2) -> (eqState S1 (restrictState S1 (ResTriplets L))) ->
  (eqState S2 (restrictState S2 (ResTriplets L))).
Intros S1 S2 L H'; Elim H'; Clear H' L S1 S2; Auto.
Intros S1 S2 L H' H'0.
Apply doTripletsRestrictBis with S1 := S1; Auto.
Intros a b S1 S2 S3 S4 L H' H'0 H'1 H'2 H'3 H'4 H'5 H'6.
Apply eqStateTrans with S2 := (interState S2 S3); Auto.
Apply eqStateTrans
     with S2 :=
          (interState
             (restrictState S2 (ResTriplets L))
             (restrictState S3 (ResTriplets L))); Auto.
Apply interStateEq; Auto.
Apply H'2; Auto.
Apply eqStateTrans with S2 := (addEq (a, b) (restrictState S1 (ResTriplets L)));
 Auto; Auto.
Apply eqStateSym.
Apply restrictAddIn; Auto.
Apply H'4.
Apply eqStateTrans
     with S2 := (addEq (a, (rZComp b)) (restrictState S1 (ResTriplets L)));
 Auto; Auto.
Apply eqStateSym.
Apply restrictAddIn; Auto.
Generalize H'0; Case b; Simpl; Auto.
Apply eqStateTrans with S2 := (restrictState (interState S2 S3) (ResTriplets L));
 Auto.
Apply eqStateSym.
Apply restrictInter; Auto.
Apply restrictEqComp; Auto.
Qed.

Theorem dilemmaP'Comp:
  (S1, S2, S3, S4:State)
  (L:(list triplet))
  (dilemmaP' S1 L S2) -> (eqState S3 S1) -> (eqState S4 S2) ->
  (dilemmaP' S3 L S4).
Intros S1 S2 S3 S4 L H'; Generalize S3 S4; Elim H'; Clear H' L S1 S2 S3 S4.
Intros S1 S2 L H' S3 S4 H'0 H'1; Apply dilemmaP'Ref; Auto.
Apply doTripletsComp with S1 := S1 S2 := S2; Auto.
Intros a b S1 S2 S3 S4 L H' H'0 H'1 H'2 H'3 H'4 H'5 S0 S5 H'6 H'7.
Apply dilemmaP'Split with a := a b := b S2 := S2 S3 := S3; Auto.
Apply eqStateTrans with S2 := S4; Auto.
Qed.

Theorem restrictDilemmaP'CompAux1:
  (S1, S2:State) (L:(list triplet)) (dilemmaP' S1 L S2) ->
  (S3:State) (eqState S1 (restrictState S3 (ResTriplets L))) ->
  (eqState S2 (restrictState S2 (ResTriplets L))).
Intros S1 S2 L H'; Elim H'; Clear H' L S1 S2.
Intros S1 S2 L H' S3 H'0.
Apply restrictDoTripletsCompAux1 with S1 := S1 S3 := S3; Auto.
Intros a b S1 S2 S3 S4 L H' H'0 H'1 H'2 H'3 H'4 H'5 S0 H'6.
Apply eqStateTrans with S2 := (restrictState (interState S2 S3) (ResTriplets L));
 Auto.
Apply eqStateTrans
     with S2 :=
          (interState
             (restrictState S2 (ResTriplets L))
             (restrictState S3 (ResTriplets L))); Auto.
Apply eqStateTrans with S2 := (interState S2 S3); Auto.
Apply interStateEq; Auto.
Apply H'2 with S3 := (addEq (a, b) (restrictState S0 (ResTriplets L))); Auto.
Apply eqStateTrans with S2 := (addEq (a, b) (restrictState S0 (ResTriplets L)));
 Auto.
Apply eqStateTrans
     with S2 :=
          (addEq
             (a, b)
             (restrictState (restrictState S0 (ResTriplets L)) (ResTriplets L)));
 Auto.
Apply eqStateAddEq; Auto.
Apply restrictStateInvol; Auto.
Apply eqStateSym.
Apply RestrictAddEq; Auto.
Apply H'4 with S0 := (addEq (a, (rZComp b)) (restrictState S0 (ResTriplets L))).
Apply eqStateTrans
     with S2 := (addEq (a, (rZComp b)) (restrictState S0 (ResTriplets L))); Auto.
Apply eqStateTrans
     with S2 :=
          (addEq
             (a, (rZComp b))
             (restrictState (restrictState S0 (ResTriplets L)) (ResTriplets L)));
 Auto.
Apply eqStateAddEq; Auto.
Apply restrictStateInvol; Auto.
Apply eqStateSym.
Apply RestrictAddEq; Auto.
Generalize H'0; Case b; Auto.
Apply eqStateSym.
Apply restrictInter; Auto.
Apply restrictEqComp; Auto.
Qed.

Theorem restrictDilemmaP'Comp:
  (S1, S2:State)
  (L:(list triplet)) (dilemmaP' (restrictState S1 (ResTriplets L)) L S2) ->
  (eqState S2 (restrictState S2 (ResTriplets L))).
Intros S1 S2 L H'.
Apply restrictDilemmaP'CompAux1
     with S1 := (restrictState S1 (ResTriplets L)) S3 := S1; Auto.
Qed.

Theorem dilemmaPdilemmaP'Incl:
  (S1, S2:State) (L:(list triplet)) (dilemmaP S1 L S2) ->
  (Ex [S3:State]
  (dilemmaP' (restrictState S1 (ResTriplets L)) L S3) /\
  (inclState (restrictState S2 (ResTriplets L)) S3)).
Intros S1 S2 L H'; Elim H'; Clear H' L S1 S2.
Intros S1 S2 L H'; Exists (restrictState S2 (ResTriplets L)); Split; Auto.
Apply dilemmaP'Ref; Auto.
Apply doTripletsRestrict; Auto.
Intros a b S1 S2 S3 S4 L H' H'0 H'1 H'2 H'3.
Case (getAlternativePair a b S1 L).
Intros x; Case x; Clear x.
Intros p; Case p; Clear p; Intros a' b'.
Intros H'4; Elim H'4; Intros H'5 H'6; Elim H'5; Intros H'7 H'8; Elim H'7;
 Intros H'9 H'10; Clear H'7 H'5 H'4.
Elim H'0; Intros S5 E; Elim E; Intros H'4 H'5; Clear E H'0.
Elim H'2; Intros S0 E; Elim E; Intros H'0 H'7; Clear E H'2.
Exists (interState S5 S0); Split; Auto.
Apply dilemmaP'Split with a := a' b := b' S2 := S5 S3 := S0; Auto.
Apply dilemmaP'Comp
     with S1 := (restrictState (addEq (a, b) S1) (ResTriplets L)) S2 := S5; Auto.
Apply eqStateTrans
     with S2 := (restrictState (addEq (a', b') S1) (ResTriplets L)).
Apply eqStateSym.
Apply restrictAddIn; Auto.
Apply restrictEqComp; Auto.
Apply dilemmaP'Comp
     with S1 := (restrictState (addEq (a, (rZComp b)) S1) (ResTriplets L))
          S2 := S0; Auto.
Apply eqStateTrans
     with S2 := (restrictState (addEq (a', (rZComp b')) S1) (ResTriplets L)).
Apply eqStateSym.
Apply restrictAddIn; Auto.
Generalize H'10; Case b'; Auto.
Apply restrictEqComp; Auto.
Apply inclStateEqStateComp
     with S1 := (restrictState (interState S2 S3) (ResTriplets L))
          S3 := (interState S5 S0); Auto.
Apply restrictEqComp; Auto.
Apply interMemMin; Auto.
Apply inclStateTrans with S2 := (restrictState S2 (ResTriplets L)); Auto.
Apply restricMonotone; Auto with datatypes.
Apply inclStateTrans with S2 := (restrictState S3 (ResTriplets L)); Auto.
Apply restricMonotone; Auto with datatypes.
Intros H'4; Elim H'4; Intros H'5 H'6; Clear H'4.
Elim H'0; Intros S5 E; Elim E; Intros H'4 H'7; Clear E H'0.
Exists S5; Split; Auto.
Apply dilemmaP'Comp
     with S1 := (restrictState (addEq (a, b) S1) (ResTriplets L)) S2 := S5; Auto.
Apply inclStateTrans with S2 := (restrictState S2 (ResTriplets L)); Auto.
Apply restricMonotone; Auto with datatypes.
Apply inclStateEqStateComp with S1 := (interState S2 S3) S3 := S2; Auto.
Qed.

Theorem dilemmaP'MonotoneEx:
  (S1, S2, S3:State)
  (L:(list triplet)) (dilemmaP' S1 L S3) -> (inclState S1 S2) ->
  (Ex [S4:State] (dilemmaP' S2 L S4) /\ (inclState S3 S4)).
Intros S1 S2 S3 L H'; Generalize S2; Elim H'; Auto; Clear H' L S1 S2 S3.
Intros S1 S3 L H' S2 H'0.
Elim (doTripletsMonotoneEx S1 S2 S3 L);
 [Intros S4 E; Elim E; Intros H'7 H'8; Clear E | Idtac | Idtac]; Auto.
Exists S4; Split; Auto.
Apply dilemmaP'Ref; Auto.
Intros a b S1 S2 S3 S4 L H' H'0 H'1 H'2 H'3 H'4 H'5 S0 H'6.
Elim (H'2 (addEq (a, b) S0));
 [Intros S5 E; Elim E; Intros H'7 H'8; Clear E | Idtac]; Auto.
Elim (H'4 (addEq (a, (rZComp b)) S0));
 [Intros S6 E; Elim E; Intros H'11 H'12; Clear E | Idtac]; Auto.
Exists (interState S5 S6); Split; Auto.
Apply dilemmaP'Split with 3 := H'7 4 := H'11; Auto.
Apply inclStateEqStateComp
     with S1 := (interState S2 S3) S3 := (interState S5 S6); Auto.
Apply interMemMin; Auto.
Apply inclStateTrans with S2 := S2; Auto.
Apply inclStateTrans with S2 := S3; Auto.
Qed.

Mutual Inductive stalmarckP': State -> (list triplet) -> State ->Prop :=
     stalmarckP'ref:
       (S1, S2:State) (L:(list triplet)) (eqState S1 S2) ->(stalmarckP' S1 L S2)
    | stalmarckP'Trans:
        (S1, S2, S3:State)
        (L:(list triplet)) (dilemmaP' S1 L S2) -> (stalmarckP' S2 L S3) ->
        (stalmarckP' S1 L S3) .

Theorem stalmarckP'ImpStalmarckP:
  (S1, S2:State) (L:(list triplet)) (stalmarckP' S1 L S2) ->(stalmarckP S1 L S2).
Intros S1 S2 L H'; Elim H'; Clear H' L S2 S1; Auto.
Intros S1 S2 S3 L H' H'0 H'1.
Apply stalmarckTrans with S2 := S2; Auto.
Apply dilemmaP'ImpdilemmaP; Auto.
Qed.

Theorem stalmarckP'MonotoneEx:
  (S1, S2, S3:State)
  (L:(list triplet)) (stalmarckP' S1 L S3) -> (inclState S1 S2) ->
  (Ex [S4:State] (stalmarckP' S2 L S4) /\ (inclState S3 S4)).
Intros S1 S2 S3 L H'; Generalize S2; Elim H'; Auto; Clear H' L S1 S2 S3.
Intros S1 S2 L H' S0 H'0; Exists S0; Split; Auto.
Apply stalmarckP'ref; Auto.
Apply inclStateEqStateComp with S1 := S1 S3 := S0; Auto.
Intros S1 S2 S3 L H' H'0 H'1 S0 H'2.
Elim (dilemmaP'MonotoneEx S1 S0 S2 L);
 [Intros S4 E; Elim E; Intros H'9 H'10; Clear E | Idtac | Idtac]; Auto.
Elim (H'1 S4); [Intros S5 E; Elim E; Intros H'5 H'6; Clear E | Idtac]; Auto.
Exists S5; Split; Auto.
Apply stalmarckP'Trans with S2 := S4; Auto.
Qed.

Theorem stalmarckPstalmarckP'Incl:
  (S1, S2:State) (L:(list triplet)) (stalmarckP S1 L S2) ->
  (Ex [S3:State]
  (stalmarckP' (restrictState S1 (ResTriplets L)) L S3) /\
  (inclState (restrictState S2 (ResTriplets L)) S3)).
Intros S1 S2 L H'; Elim H'; Clear H' L S1 S2; Auto.
Intros S1 S2 L H'; Exists (restrictState S2 (ResTriplets L)); Split; Auto.
Apply stalmarckP'ref; Auto.
Apply restrictEqComp; Auto.
Intros S1 S2 S3 L H' H'0 H'1.
Elim H'1; Intros S0 E; Elim E; Intros H'2 H'3; Clear E H'1; Auto.
Elim (dilemmaPdilemmaP'Incl S1 S2 L);
 [Intros S4 E; Elim E; Intros H'7 H'8; Clear E | Idtac]; Auto.
Elim (stalmarckP'MonotoneEx (restrictState S2 (ResTriplets L)) S4 S0 L);
 [Intros S5 E; Elim E; Intros H'11 H'12; Clear E | Idtac | Idtac]; Auto.
Exists S5; Split; Auto.
Apply stalmarckP'Trans with S2 := S4; Auto.
Apply inclStateTrans with S2 := S0; Auto.
Qed.

Theorem restrictStalmarckP'CompAux1:
  (S1, S2:State) (L:(list triplet)) (stalmarckP' S1 L S2) ->
  (S3:State) (eqState S1 (restrictState S3 (ResTriplets L))) ->
  (eqState S2 (restrictState S2 (ResTriplets L))).
Intros S1 S2 L H'; Elim H'; Clear H' L S1 S2.
Intros S1 S2 L H' S3 H'0.
Apply restrictDoTripletsCompAux1 with S1 := S1 S3 := S3; Auto.
Intros S1 S2 S3 L H' H'0 H'1 S0 H'2.
Apply H'1 with S0 := S2; Auto.
Apply restrictDilemmaP'CompAux1 with S1 := S1 S3 := S0; Auto.
Qed.

Theorem restrictStalmarckP'Comp:
  (S1, S2:State)
  (L:(list triplet)) (stalmarckP' (restrictState S1 (ResTriplets L)) L S2) ->
  (eqState S2 (restrictState S2 (ResTriplets L))).
Intros S1 S2 L H'.
Apply restrictStalmarckP'CompAux1
     with S1 := (restrictState S1 (ResTriplets L)) S3 := S1; Auto.
Qed.
