Require Import array.
Require Import memoryImplement.
Require Import OrderedListEq.
Require Import triplet.
Require Import LetP.
Section algo.
Variable LL:(list triplet).
Variable maxN:rNat.
Hypothesis HmaxN:maxN=(rnext (maxVarTriplets LL)).

Definition varListInit := (genArray maxN ? [a:rNat] [_:?](nil triplet)).

Theorem maxNRlt:
  (L1, L2:(list triplet))
  (a:rZ)
  (inTriplets a L1) ->
  ~ (rlt (rnext (maxVarTriplets L2)) (rnext (maxVarTriplets L1))) ->
  (rlt (valRz a) (rnext (maxVarTriplets L2))).
Intros L1; Elim L1; Simpl; Auto.
Intros L2 a H' H'0.
Case eqRzElim with 1 := H'; Intros H'1; Rewrite H'1; Simpl; Auto.
Intros a l H' L2 a0 H'0; Elim H'0; Auto.
2:Intros H'1 H'2.
2:Apply H' with L2 := L2; Auto.
2:Red; Intros H'3; Case H'2; Auto.
2:Apply rltTransRnext2 with m := (rnext (maxVarTriplets l)); Auto.
Case a; Simpl; Auto.
Intros b p q r H'2.
Elim H'2; Clear H'2; Unfold eqRz; Intros H'2;
 [Idtac | Elim H'2; Clear H'2; Intros H'2]; Rewrite H'2; Intros H'3.
Case (rltDec (valRz p) (rnext (maxVarTriplets L2))); Intros s;
 [Case s; Clear s; Intros s | Idtac]; Auto.
Case H'3; Auto.
Apply rltTransRnext2 with 1 := s; Auto.
Apply rltTransRnext1 with m := (rmax (rmax (valRz p) (valRz q)) (valRz r)); Auto.
Apply rltTransRnext1 with m := (rmax (valRz p) (valRz q)); Auto.
Apply rltTrans
     with y :=
          (rnext
             (rmax
                (rmax (rmax (valRz p) (valRz q)) (valRz r)) (maxVarTriplets l)));
 Auto.
Case H'3; Auto.
Rewrite <- s; Auto.
Apply rltTransRnext1 with m := (rmax (rmax (valRz p) (valRz q)) (valRz r)); Auto.
Apply rltTransRnext1 with m := (rmax (valRz p) (valRz q)); Auto.
Case (rltDec (valRz q) (rnext (maxVarTriplets L2))); Intros s;
 [Case s; Clear s; Intros s | Idtac]; Auto.
Case H'3; Auto.
Apply rltTransRnext2 with 1 := s; Auto.
Apply rltTransRnext1 with m := (rmax (rmax (valRz p) (valRz q)) (valRz r)); Auto.
Apply rltTransRnext1 with m := (rmax (valRz p) (valRz q)); Auto.
Apply rltTrans
     with y :=
          (rnext
             (rmax
                (rmax (rmax (valRz p) (valRz q)) (valRz r)) (maxVarTriplets l)));
 Auto.
Case H'3; Auto.
Apply rltTransRnext1 with m := (rmax (rmax (valRz p) (valRz q)) (valRz r)); Auto.
Apply rltTransRnext1 with m := (rmax (valRz p) (valRz q)); Auto.
Rewrite s; Auto.
Case (rltDec (valRz r) (rnext (maxVarTriplets L2))); Intros s;
 [Case s; Clear s; Intros s | Idtac]; Auto.
Case H'3; Auto.
Apply rltTransRnext2 with 1 := s; Auto.
Apply rltTransRnext1 with m := (rmax (rmax (valRz p) (valRz q)) (valRz r)); Auto.
Apply rltTrans
     with y :=
          (rnext
             (rmax
                (rmax (rmax (valRz p) (valRz q)) (valRz r)) (maxVarTriplets l)));
 Auto.
Case H'3; Auto.
Apply rltTransRnext1 with m := (rmax (rmax (valRz p) (valRz q)) (valRz r)); Auto.
Rewrite s; Auto.
Qed.

Definition addVarList:
  (L:(list triplet))
  (HL:~ (rlt maxN (rnext (maxVarTriplets L))))
  (Ar:(Array maxN (list triplet))) (incl L LL) ->
  {Ar2:(Array maxN (list triplet)) |
    (((a:rNat) (Ha:(rlt a maxN))(incl (getAval maxN ? Ar a Ha) LL)) ->
     (a:rNat) (Ha:(rlt a maxN))(incl (getAval maxN ? Ar2 a Ha) LL)) /\
    ((t:triplet)
     (a:rNat) (Ha:(rlt a maxN)) (In t L) -> (inTriplet (rZPlus a) t) ->
     (In t (getAval maxN ? Ar2 a Ha)))}.
Intros L; Elim L.
Intros HL Ar Incl0; Exists Ar; Split; Auto.
Intros t a0 Ha0 H'; Inversion H'; Auto.
Intros a; Case a.
Intros b p q r l Rec H A1 Incl0.
Cut ~ (rlt maxN (rnext (maxVarTriplets l))); [Intros Neq | Idtac].
Cut (incl l LL); [Intros Incl1 | Idtac].
Apply LetP with h := (Rec Neq A1 Incl1).
Intros rec; Case rec.
Intros A2 HA2.
Elim HA2; Intros H' H'0.
Cut (rlt (valRz p) maxN); [Intros Hp | Idtac].
Cut (rlt (valRz q) maxN); [Intros Hq | Idtac].
Cut (rlt (valRz r) maxN); [Intros Hr | Idtac].
Apply LetP with h := (getAval maxN ? A2 (valRz p) Hp); Intros Lp HLp.
Apply LetP with h := (getAval maxN ? A2 (valRz q) Hq); Intros Lq HLq.
Apply LetP with h := (getAval maxN ? A2 (valRz r) Hr); Intros Lr HLr.
Exists (setAval
          maxN ?
          (setAval
             maxN ? (setAval maxN ? A2 (valRz p) Hp (cons (Triplet b p q r) Lp))
             (valRz q) Hq (cons (Triplet b p q r) Lq)) (valRz r) Hr
          (cons (Triplet b p q r) Lr)); Split; Auto.
Intros H'1 a0 Ha.
Case (rNatDec a0 (valRz r)); Intros Eqr.
Rewrite getAvalIrr with m2 := (valRz r) Hm2 := Hr; Auto.
Rewrite setAvalDef1; Auto.
Rewrite HLr; Auto with datatypes.
Rewrite setAvalDef2; Auto.
Case (rNatDec a0 (valRz q)); Intros Eqq.
Rewrite getAvalIrr with m2 := (valRz q) Hm2 := Hq; Auto.
Rewrite setAvalDef1; Auto.
Rewrite HLq; Auto with datatypes.
Rewrite setAvalDef2; Auto.
Case (rNatDec a0 (valRz p)); Intros Eqp.
Rewrite getAvalIrr with m2 := (valRz p) Hm2 := Hp; Auto.
Rewrite setAvalDef1; Auto.
Rewrite HLp; Auto with datatypes.
Rewrite setAvalDef2; Auto.
Simpl.
Intros t a0 Ha H'1; Elim H'1; Clear H'1; Intros H'1; [Rewrite <- H'1 | Idtac];
 Auto.
Simpl; Unfold eqRz; Simpl; Intros H'2.
Case (rNatDec a0 (valRz r)); Intros Eqr.
Rewrite getAvalIrr with m2 := (valRz r) Hm2 := Hr; Auto.
Rewrite setAvalDef1; Auto with datatypes.
Rewrite setAvalDef2; Auto.
Case (rNatDec a0 (valRz q)); Intros Eqq.
Rewrite getAvalIrr with m2 := (valRz q) Hm2 := Hq; Auto.
Rewrite setAvalDef1; Auto with datatypes.
Rewrite setAvalDef2; Auto.
Case (rNatDec a0 (valRz p)); Intros Eqp.
Rewrite getAvalIrr with m2 := (valRz p) Hm2 := Hp; Auto.
Rewrite setAvalDef1; Auto with datatypes.
Rewrite HLp; Auto with datatypes.
Rewrite setAvalDef2; Auto.
Elim H'2; Clear H'2; Intros H'2; [Idtac | Elim H'2; Clear H'2; Intros H'2]; Auto.
Case Eqp; Auto.
Case Eqq; Auto.
Case Eqr; Auto.
Intros H'2.
Case (rNatDec a0 (valRz r)); Intros Eqr.
Rewrite getAvalIrr with m2 := (valRz r) Hm2 := Hr; Auto.
Rewrite setAvalDef1; Auto with datatypes.
Rewrite HLr; Auto with datatypes.
Simpl; Right; Auto.
Apply H'0; Auto.
Rewrite <- Eqr; Auto.
Rewrite setAvalDef2; Auto.
Case (rNatDec a0 (valRz q)); Intros Eqq.
Rewrite getAvalIrr with m2 := (valRz q) Hm2 := Hq; Auto.
Rewrite setAvalDef1; Auto with datatypes.
Rewrite HLq; Auto.
Simpl; Right; Auto.
Apply H'0; Auto.
Rewrite <- Eqq; Auto.
Rewrite setAvalDef2; Auto.
Case (rNatDec a0 (valRz p)); Intros Eqp.
Rewrite getAvalIrr with m2 := (valRz p) Hm2 := Hp; Auto.
Rewrite setAvalDef1; Auto with datatypes.
Rewrite HLp; Auto with datatypes.
Simpl; Right; Auto.
Apply H'0; Auto.
Rewrite <- Eqp; Auto.
Rewrite setAvalDef2; Auto.
Rewrite HmaxN; Apply maxNRlt with L1 := (cons (Triplet b p q r) l); Simpl; Auto.
Rewrite <- HmaxN; Auto.
Rewrite HmaxN; Apply maxNRlt with L1 := (cons (Triplet b p q r) l); Simpl; Auto;
 Rewrite <- HmaxN; Auto.
Rewrite HmaxN; Apply maxNRlt with L1 := (cons (Triplet b p q r) l); Simpl; Auto;
 Rewrite <- HmaxN; Auto.
Apply incl_tran with 2 := Incl0; Auto with datatypes.
Red; Intros H'; Case H; Auto.
Apply rltTransRnext2 with m := (rnext (maxVarTriplets l)); Auto.
Simpl; Auto.
Defined.

Definition varList: (v:rZ) (rVlt v maxN) ->(list triplet).
Cut ~ (rlt maxN (rnext (maxVarTriplets LL))); [Intros H | Idtac].
Apply LetP
     with h :=
          (addVarList
             LL H (genArray maxN ? [a:rNat] [_:?](nil triplet))
             (!incl_refl ? LL)).
Intros x; Case x.
Intros Ar Har Hx.
Intros v Hv.
Exact (getAval maxN (list triplet) Ar (valRz v) Hv).
Rewrite HmaxN; Auto.
Defined.

Theorem varListIn: (v:rZ) (Hv:(rVlt v maxN))(incl (varList v Hv) LL).
Intros v Hv.
Unfold varList LetP; Simpl.
Case (addVarList
        LL
        (eq_ind_r
           rNat (rnext (maxVarTriplets LL))
           [r:rNat]~ (rlt r (rnext (maxVarTriplets LL)))
           (rltNotRefl (rnext (maxVarTriplets LL))) maxN HmaxN)
        (genArray maxN (list triplet) [a:rNat] [_:(rlt a maxN)](nil triplet))
        (!incl_refl triplet LL)); Auto.
Intros x H'.
Elim H'; Intros H'0 H'1; Apply H'0; Clear H'; Auto.
Intros a Ha.
Rewrite genArrayDef; Auto with datatypes.
Elim LL; Auto with datatypes.
Qed.

Theorem varListComplete:
  (t:triplet) (a:rZ) (Ha:(rVlt a maxN)) (In t LL) -> (inTriplet a t) ->
  (In t (varList a Ha)).
Intros v Hv.
Unfold varList; Unfold LetP; Simpl.
Case (addVarList
        LL
        (eq_ind_r
           rNat (rnext (maxVarTriplets LL))
           [r:rNat]~ (rlt r (rnext (maxVarTriplets LL)))
           (rltNotRefl (rnext (maxVarTriplets LL))) maxN HmaxN)
        (genArray maxN (list triplet) [a:rNat] [_:(rlt a maxN)](nil triplet))
        (!incl_refl triplet LL)); Auto.
Intros x H'.
Intros Ha H'0 H'1.
Elim H'; Intros H'2 H'3; Apply H'3; Clear H'; Auto.
Qed.
End algo.
